# Kronecker.jl

![](logo.png)

This is a Julia package to efficiently work with Kronecker products. It combines lazy evaluation and algebraic tricks such that it can implicitely work with huge matrices. It allows to work with large Kronecker systems both much faster and using much less memory than the naive implementation of the Kronecker product.

## Features

Given two matrices (subtype of `AbstractArray`) `A` and `B`, one can construct an instance of the `KroneckerProduct` type as `K = A ⊗ B` (typed using `\otimes TAB`). Equivalently, the function `kronecker` function can be used as well. Several functions are implemented.

- `collect(K)` computes the Kronecker product (**not** recommended!)
- `tr`, `det`, `size`, `eltype`, `inv`, ... are efficient functions to work with Kronecker products. Either the result is a numeric value or a new `KroneckerProduct` type is returned
- Multiplying with a vector `v` is efficient using the [vec trick](https://en.wikipedia.org/wiki/Kronecker_product#Matrix_equations): `K * v`
- Solving systems of the form `A ⊗ B + cI`
- Working with incomplete systems using the [sampled vec trick](https://arxiv.org/pdf/1601.01507.pdf)
- Basic compatibility with higher-order Kronecker systems, e.g. `A ⊗ B ⊗ C` or `kronecker(A, 4)` which is equivalent with `A ⊗ A ⊗ A ⊗ A`
- A `KroneckerSum` can be constructed with `A ⊕ B` (typed using `\oplus TAB`) or `kroneckersum(A,B)`
  - Multiplication with vectors uses  a specialized version of the vec trick
  - Higher-order sums are supported, e.g. `A ⊕ B ⊕ C` or `kroneckersum(A,4)`
- [in progress] GPU compatibility!
- [in progress] Autodiff for machine learning models!

Read the [documentation](https://michielstock.github.io/Kronecker.jl/stable/) to get the specifics.

## Benchmarks

Below is a [comparision](scrips/benchmarks.jl) between the native `kron` function and `Kronecker.jl` for several operations.

![](benchmark.svg)

## Example

```julia
using Kronecker

A = randn(100, 100);
B = rand(50, 50);

v = rand(5000);

K = A ⊗ B

collect(K)  # equivalent with kron(A, B)

K[78, 43]

tr(K)
inv(K)  # yields another lazy Kronecker instance

K * v  # equivalent with vec(B * reshape(v, 50, 100) * A')
```

See the notebook for some more advanced use.

## Installation

Directly available via the Julia package manager:

```julialang
] add Kronecker
```

## Issues

This is very much a work in progress! Please start an issue for bugs or requests to improve functionality. Any feedback is appreciated!

## Status `master` branch

[![stable docs](https://img.shields.io/badge/docs-stable-blue.svg)](https://michielstock.github.io/Kronecker.jl/stable/)[![dev docs](https://img.shields.io/badge/docs-dev-blue.svg)](https://michielstock.github.io/Kronecker.jl/dev/)[![build status](https://github.com/MichielStock/Kronecker.jl/workflows/CI/badge.svg)](https://github.com/MichielStock/Kronecker.jl/actions?query=workflow%3ACI) [![coverage](http://codecov.io/github/MichielStock/Kronecker.jl/coverage.svg?branch=master)](http://codecov.io/github/MichielStock/Kronecker.jl?branch=master) [![DOI](https://zenodo.org/badge/160198570.svg)](https://zenodo.org/badge/latestdoi/160198570)[![JULIACON](https://proceedings.juliacon.org/papers/10.21105/jcon.00015/status.svg)](https://doi.org/10.21105/jcon.00015)

@testset "Kronecker graphs" begin
    P1 = [0.1 0.0 0.0;
          0.3 0.4 0.5;
          1.0 0.7 0.2]

    P2 = [0.1 0.1 0.0;
          0.3 0.4 0.6;
          1.0 0.2 0.2]

    P = P1 ⊗ P2

    P4order = kronecker(P1, 4)

    @testset "Naive sample" begin
          G = naivesample(P)
          @test G isa AbstractSparseMatrix
          @test size(G) == size(P)
          @test G[9, 1]  # probability of 1
          @test !G[2, 5]  # probability of 0
    end

    @testset "Fast sample" begin
          G = fastsample(P)
          @test G isa AbstractSparseMatrix
          @test size(G) == size(P)
          # exact sample does not always generate this, so don't test
          #@test G[9, 1]  # probability of 1
          @test !G[2, 5]  # probability of 0
    end

    @testset "helpers" begin
         @test isprob(P1)
         @test !isprob([2 .01; 0.2 0])
         @test isprob(P)
         @test isprob(P4order)

         indices = sampleindices(P1, 100)
         @test all(maximum(indices) .<= size(P1))
         for ind in indices
               @test P1[ind...] > 0
         end

         indices = sampleindices(P, 100)
         @test all(maximum(indices) .<= size(P))
         for ind in indices
               @test P[ind...] > 0
         end

         indices = sampleindices(P4order, 1000)
         @test all(maximum(indices) .<= size(P4order))
         for ind in indices
               @test P4order[ind...] > 0
         end
   end

end

@testset "Kronecker products" begin

    A = randn(4, 4)
    B = Array{Float64,2}([1 2 3
        4 5 6
        7 -2 9])
    C = rand(5, 6)
    D = rand(4, 4)

    v = rand(12)

    K = A ⊗ B
    K3 = kronecker(A, B, C)

    L = kronecker(A, B .+ im)

    Kc = collect(K)
    K3c = collect(K3)

    X = kron(A, B)  # true result

    @testset "Types and basic properties" begin
        @test issquare(A)
        @test !issquare(C)

        @test getmatrices(A)[1] === A

        @test !issymmetric(A)

        @test issquare(K)
        @test !issymmetric(K)

        @test K ≈ X
        @test collect!(similar(X), K) ≈ X

        @test order(A) == 1
        @test order(K) == 2

        @test eltype(K) <: Float64

        @test K isa AbstractKroneckerProduct
        @test K isa AbstractKroneckerProduct{Float64}

        @test K isa AbstractMatrix{Float64}

        @test copy(K) isa AbstractKroneckerProduct

        Kcopy = deepcopy(K)
        @test Kcopy ≈ K
        @test Kcopy isa AbstractKroneckerProduct

        @test similar(K) isa AbstractKroneckerProduct

        if VERSION ≥ v"1.1"
            Kcopy = similar(A) ⊗ similar(B)
            @test_nowarn copy!(Kcopy, K)
            @test Kcopy ≈ K
        end
    end

    @testset "Using vectors" begin
        @test A ⊗ v ≈ kron(A, v)
        @test v ⊗ B ≈ kron(v, B)
        c = rand(1:10, 5)
        @test all(c ⊗ v .≈ kron(c, v))
    end

    @testset "Trivial case" begin
        @test kronecker(A) isa Matrix
        @test ⊗(B) isa Matrix
        @test kronecker(v) isa Vector
        @test kronecker(K) isa AbstractKroneckerProduct
    end

    # testing all linear algebra functions' behavior on square and non-square matrices
    function test_non_square_extensions()
        local n, m, A, B, K, M
        n, m = 3, 5
        # 1. K is square, while A, B aren't
        A = randn(n, m)
        B = randn(m, n)
        K = A ⊗ B
        M = Matrix(K)
        @test K ≈ M
        @test collect!(similar(M), K) ≈ M
        @test tr(K) ≈ tr(M)
        @test det(K) ≈ 0
        @test diag(K) ≈ diag(M)
        @test logdet(K) ≈ -Inf
        @test !isposdef(K)
        @test !issymmetric(K)
        @test LinearAlgebra.checksquare(K) == size(K, 1) # should not throw on square matrix
        @test_throws SingularException inv(K) # if K is square but singular

        # 2. K is not square
        A = randn(n, m)
        B = randn(m, m)
        K = A ⊗ B
        @test !isposdef(K)
        @test !issymmetric(K)
        @test_throws DimensionMismatch tr(K)
        @test_throws DimensionMismatch det(K)
        @test_throws DimensionMismatch logdet(K)
        @test_throws DimensionMismatch LinearAlgebra.checksquare(K)
        @test_throws DimensionMismatch inv(K)
    end

    @testset "Linear algebra" begin
        @test tr(K) ≈ tr(X)
        @test det(K) ≈ det(X)
        @test !isposdef(K)
        @test transpose(K) ≈ transpose(X)
        @test permutedims(K) ≈ permutedims(X)
        @test conj(K) ≈ conj(X)
        @test K' ≈ X'
        @test inv(K) ≈ inv(X)
        @test diag(K) ≈ diag(X)

        # test on pos def functions
        As = A' * A
        Bs = B * B'
        @test logdet(As ⊗ Bs) ≈ log(det(As ⊗ Bs)) ≈ log(det(kron(As, Bs)))

        test_non_square_extensions()

        # test power_by_squaring
        local _m
        local K2
        _m = reshape(1:4, 2, 2)
        K2 = kronecker(_m, _m)
        @test (@inferred K2^2) == K2 * K2 == collect(K2)^2

        @test svdvals(K) ≈ svdvals(Kc) ≈ svdvals(X)
        @test rank(K) == rank(Kc) == rank(X)

        # multiplication of kronecker product of Diagonal
        Kd = Diagonal(A) ⊗ Diagonal(B)
        DKd = Diagonal(Kd)
        Kd2 = Diagonal(B) ⊗ Diagonal(A)
        DKd2 = Diagonal(Kd2)
        @test K * Kd ≈ X * DKd
        @test Kd * K ≈ DKd * X
        @test Kd * Kd ≈ DKd * DKd
        @test Diagonal(Kd) * Kd2 ≈ DKd * DKd2
        @test Kd2 * Diagonal(Kd) ≈ DKd2 * DKd
    end

    @testset "Mismatch errors" begin
        P, Q = rand(10, 4), rand(4, 5)
        Kns = P ⊗ Q
        @test_throws DimensionMismatch inv(Kns)
        @test_throws DimensionMismatch det(Kns)
        @test_throws DimensionMismatch Kns * [1, 2, 3]
    end

    @testset "Higher order" begin
        @test order(K ⊗ A) == 3
        @test order(K3) == 3
        @test collect(K3) ≈ kron(X, C)
        C3 = zeros(size(K3)...)
        @test collect!(C3, K3) ≈ K3
    end

    @testset "Kronecker powers" begin
        Kpow = ⊗(A, 5)
        @test order(Kpow) == 5
        @test size(Kpow, 1) == 4^5
        @test Kpow[1, 1] ≈ A[1, 1]^5
    end

    @testset "kron" begin
        @test kron(A ⊗ B, C) ≈ kron(A, B, C)
        @test kron(A, B ⊗ C) ≈ kron(A, B, C)
        @test kron(A ⊗ B, C ⊗ D) ≈ kron(A, B, C, D)
        M = kron(A, B, C, D)
        @test collect((A ⊗ B) ⊗ (C ⊗ D)) ≈ M
        @test collect!(similar(M), (A ⊗ B) ⊗ (C ⊗ D)) ≈ M
    end

    @testset "Mixed product" begin
        A = rand(5, 4)
        B = rand(2, 3)
        C = rand(4, 6)
        D = rand(3, 4)

        K1 = (A ⊗ B)
        K2 = (C ⊗ D)

        @test K1 * K2 ≈ collect(K1) * collect(K2)

        @test_throws DimensionMismatch (A ⊗ C) * (B ⊗ D)
        @test_throws DimensionMismatch (A ⊗ D) * (C ⊗ B)
    end

    @testset "diagonal" begin
        local A = rand(2, 2) ⊗ rand(3, 3)
        local AD = Kronecker.diagonal(A)
        @test AD isa Kronecker.KroneckerProduct
        @test AD == Diagonal(A) == Diagonal(collect(A))
        @test Kronecker.diagonal(collect(A)) == Diagonal(A)
        local B = rand(1, 2) ⊗ rand(1, 3)
        @test_throws ArgumentError Kronecker.diagonal(B)
    end

    @testset "Add to dense" begin
        @test K + X ≈ Matrix(K) + X
        @test X + K ≈ X + Matrix(K)
    end

    @testset "Arithmetic" begin
        @test K + K ≈ Kc + Kc ≈ X + X
        @test K + Kc ≈ Kc + K ≈ X + X
        @test K + K + K ≈ Kc + Kc + Kc ≈ X + X + X
        @test K3 + K3 ≈ K3c + K3c
        @test K3 + K3 + K3 ≈ K3c + K3c + K3c

        @test K - K ≈ Kc - Kc ≈ X - X
        @test K - K - K ≈ Kc - Kc - Kc ≈ X - X - X
        @test K3 - K3 ≈ K3c - K3c
        @test K3 - K3 - K3 ≈ K3c - K3c - K3c

        @test K - K + K ≈ Kc - Kc + Kc ≈ X - X + X
        @test K + K - K ≈ Kc + Kc - Kc ≈ X - X + X
        @test K - 2K + K ≈ Kc - 2Kc + Kc ≈ X - 2X + X
        @test K + 2K - K ≈ Kc + 2Kc - Kc ≈ X + 2X - X
        @test K3 - K3 + K3 ≈ K3c - K3c + K3c
        @test K3 + K3 - K3 ≈ K3c + K3c - K3c

        @test K + zero(K) ≈ Kc + zero(Kc) ≈ X + zero(X)

        @test K + L ≈ L + K ≈ Kc + collect(L)

        @test -K ≈ collect(-K) ≈ -Kc
        @test -K3 ≈ collect(-K3) ≈ -K3c

        local Kd, Kd2, Ktd, K34, K43
        Kd = rand(2, 2) ⊗ Diagonal(rand(2))
        @test -Kd ≈ collect(-Kd) ≈ -collect(Kd)
        Kd2 = Diagonal(rand(2)) ⊗ rand(2, 2)
        @test -Kd2 ≈ collect(-Kd2) ≈ -collect(Kd2)
        Ktd = rand(2, 2) ⊗ Tridiagonal(ones(3), zeros(4), ones(3))
        @test -Ktd ≈ collect(-Ktd) ≈ -collect(Ktd)
        K34 = rand(3, 3) ⊗ rand(4, 4)
        K43 = rand(4, 4) ⊗ rand(3, 3)
        @test K34 + K43 ≈ collect(K34) + collect(K43)
        @test K34 - K43 ≈ collect(K34) - collect(K43)

        @testset "add/subtract digonal and kronecker product" begin
            local D3, D4, K33, K34, K43, M33, M34, D33, D34
            D3 = Diagonal(1:3)
            D4 = Diagonal(1:4)
            K33 = kronecker(D3, D3)
            K34 = kronecker(D3, D4)
            K43 = kronecker(D4, D3)
            M33 = collect(K33)
            M34 = collect(K34)
            D33 = kron(D3, D3)
            D34 = kron(D3, D4)
            @test K33 + D33 == M33 + D33
            @test D33 + K33 == D33 + M33
            @test D34 + K34 == D34 + M34
            @test K33 + I == I + K33 == D33 + I
            @test K34 + I == I + K34 == D34 + I
            @test K33 - D33 == M33 - D33
            @test D33 - K33 == D33 - M33
            @test I - K33 == I - D33
            @test I - K34 == I - D34
            @test K33 - I == D33 - I
            @test K34 + K43 == K43 + K34 == Diagonal(K34) + Diagonal(K43)
            @test K33 + K33 == 2K33 == 2Diagonal(K33)
            @test K34 + K34 == 2K34 == 2Diagonal(K34)

            local D1, K, Kc, D2
            D1 = Diagonal(1:3)
            K = kronecker(D1, D1)
            Kc = collect(K)
            D2 = kron(D1, D1)
            @test K + D2 == Kc + D2
            @test D2 + K == D2 + Kc
            @test K + I == Kc + I
            @test I + K == I + Kc
            @test K - D2 == Kc - D2
            @test D2 - K == D2 - Kc
            @test I - K == I - Kc
            @test K - I == Kc - I

            local K3
            K3 = kronecker(D1, 3)
            @test K3 + Diagonal(K3) == Diagonal(K3) + K3 == 2Diagonal(K3)
            @test K3 - Diagonal(K3) == Diagonal(K3) - K3 == K3 - K3 == zero(Diagonal(K3))
        end
    end

    @testset "Scalar multiplication" begin
        @test 3.0K ≈ 3.0X
        @test K * 2 ≈ 2X
        @test π * K3 ≈ π * collect(K3)
        @test 3.0K isa AbstractKroneckerProduct
        @test K * 2 isa AbstractKroneckerProduct
        @test 2(K ⊗ K) isa AbstractKroneckerProduct
    end

    @testset "broadcasting" begin
        @test K .+ K == 2 .* K == K .* 2 == K + K
        @test K .+ reshape(K, size(K)..., 1) == Kc .+ reshape(Kc, size(Kc)..., 1)
        @test K .- 2 .* K == -K
        @test K .+ L == Kc + collect(L)
        Kc .= K
        @test all(Kc .== K)
        @test K .+ Kc .- K == K
        Kv = @view K[:, :]
        @test K .+ Kv == 2K
    end

    @testset "Inplace scalar multiplication" begin
        A = rand(2, 2)
        B = rand(3, 4)

        K = copy(A) ⊗ copy(B)
        lmul!(3, K)
        rmul!(K, 2)
        @test K.A ≈ 3A
        @test K.B ≈ 2B
        @test K ≈ 6kron(A, B)
    end

    @testset "Solving Linear Systems" begin
        n = 8
        m = 16
        # 1) testing square kronecker product with square A, B
        A = randn(n, n)
        B = randn(m, m)
        K = A ⊗ B
        x = randn(n * m)
        b = K * x
        @test K \ b ≈ x
        @test (x' * K) / K ≈ x'

        # testing least squares solution
        function test_ls_solve(size_A, size_B)
            A = randn(size_A)
            B = randn(size_B)
            x = randn(size(A, 2) * size(B, 2))
            K = kronecker(A, B)
            b = K * x
            b .+= randn(size(b)) # this moves b out of range(K), necessitating least-squares
            xls = K \ b
            return K' * (K * xls) ≈ K'b # test via normal equations
        end

        # 2) kronecker product is square, but A, B aren't
        size_A = (m, n)
        size_B = (n, m)
        @test test_ls_solve(size_A, size_B)

        # 3) kronecker product is not square, dimension of x is larger than b
        size_A = (n, n)
        size_B = (n, m)
        @test test_ls_solve(size_A, size_B)

        # 4) kronecker product is not square, dimension of x is smaller than b
        size_A = (m, n)
        size_B = (m, m)
        @test test_ls_solve(size_A, size_B)
    end
end

@testset "Kronecker sums" begin
    using SparseArrays

    As = (rand(4, 4), sprand(4, 4, 1.0))
    Bs = (rand(3, 3), sprand(3, 3, 1.0))
    Cs = (rand(5, 5), sprand(5, 5, 1.0))
    Ds = (rand(ComplexF64, 6, 6), sprand(ComplexF64, 6, 6, 1.0))
    arraytypes = (Matrix, SparseMatrixCSC)

    for (A, B, C, D, arraytype) in zip(As, Bs, Cs, Ds, arraytypes)
        IA = oneunit(A)
        IB = oneunit(B)

        KS = A ⊕ B
        kronsum = kron(A, IB) + kron(IA, B)

        @test eltype(KS) <: Float64
        @test KS isa AbstractMatrix{Float64}
        @test KS isa GeneralizedKroneckerProduct{Float64}
        @test !isa(KS, AbstractKroneckerProduct)

        @test collect(KS) ≈ kronsum
        @test collect(KS) isa AbstractSparseMatrix

        @test issquare(KS)

        @test copy(KS) isa KroneckerSum

        KScopy = deepcopy(KS)
        @test KScopy ≈ KS
        @test KScopy isa KroneckerSum

        @test similar(KS) isa KroneckerSum

        if VERSION ≥ v"1.1"
            KScopy = similar(A) ⊕ similar(B)
            @test_nowarn copy!(KScopy, KS)
            @test KScopy ≈ KS
        end

        IC = oneunit(C)
        KS3 = A ⊕ B ⊕ C
        KS3AB = (A ⊕ B) ⊕ C
        KS3BC = A ⊕ (B ⊕ C)

        kronsum3 = kron(A, IB, IC) + kron(IA, B, IC) + kron(IA, IB, C)

        for ks3 in (KS3, KS3AB, KS3BC)
            @test collect(ks3) ≈ kronsum3
            @test collect(ks3) isa AbstractSparseMatrix
            @test order(ks3) == 3
            @test getindex(ks3, 2, 3) == kronsum3[2, 3]
        end

        @test order(KS) == 2
        @test getmatrices(KS) == (A, B)
        @test getindex(KS, 2, 3) == kronsum[2, 3]

        ID = oneunit(D)

        @testset "Structure of sums" begin
            @test size(A ⊕ D) == size(A) .* size(D, 1)
            @test size(B ⊕ C ⊕ D) == size(B) .* size(C) .* size(D)
            @test eltype(A ⊕ B) == Float64
            @test eltype(C ⊕ D) == ComplexF64
        end

        @testset "Basic linear algebra for sums" begin
            @test tr(KS) ≈ tr(kronsum)
            @test KS' == kronsum'
            @test transpose(KS) == transpose(kronsum)
            @test conj(KS) == conj(kronsum)
        end

        A = rand(10, 10)
        B = rand(10, 10)
        V = Diagonal(rand(10))
        @testset "Vec trick for sums" begin
            @test (A ⊕ B) * vec(V) ≈ vec(B * V + V * transpose(A))
        end

        A = rand(3, 3)
        IA = oneunit(A)
        B = rand(4, 4)
        IB = oneunit(B)
        @testset "exp for Kronecker sum" begin
            EKS = exp(A ⊕ B)
            @test EKS isa AbstractKroneckerProduct
            @test EKS ≈ exp(kron(A, IB) + kron(IA, B))
        end

        @testset "sum over Kronecker sum" begin
            @test sum(KS) ≈ sum(kronsum)
            @test sum(KS3) ≈ sum(kronsum3)

            for dims in 1:2
                @test sum(KS, dims = dims) ≈ sum(kronsum, dims = dims)
                @test sum(KS3, dims = dims) ≈ sum(kronsum3, dims = dims)
            end

            @test_throws ArgumentError sum(KS, dims = -1)
            @test_throws ArgumentError sum(KS3, dims = 3)
        end

        @testset "sparse Kronecker sum" begin
            for ks in (KS, KS3, KS3AB, KS3BC)
                sks = sparse(ks)
                @test sks isa AbstractKroneckerSum
                @test issparse(sks.A)
                @test issparse(sks.B)

                if arraytype <: Array
                    @test !issparse(ks)
                elseif arraytype <: AbstractSparseMatrix
                    @test issparse(ks)
                end
            end
        end

        @testset "call kron on Kronecker sums" begin
            for ks in (KS, KS3, KS3AB, KS3BC)
                cks = collect(ks)
                @test kron(ks, D) ≈ kron(cks, D)
                @test kron(D, ks) ≈ kron(D, cks)
                @test kron(ks, ks) ≈ kron(cks, cks)
            end
        end
    end

end

using Kronecker, Test, LinearAlgebra, Random
using SparseArrays: AbstractSparseMatrix, SparseMatrixCSC, sprand,
    sparse, issparse

using Aqua
@testset "project quality" begin
    Aqua.test_all(Kronecker, ambiguities=false)
end

@testset "Kronecker" begin

    include("testbase.jl")
    include("testkroneckerpowers.jl")
    include("testnames.jl")
    include("testmultiply.jl")
    include("testindexed.jl")
    include("testeigen.jl")
    include("testkroneckersum.jl")
    include("testfactorization.jl")
    include("testkroneckergraphs.jl")
end

using LinearAlgebra: Eigen
import LinearAlgebra: eigen, eigvals, \, det, logdet, inv
import Base: +

"""
    eigen(K::AbstractKroneckerProduct)

Wrapper around `eigen` from the `LinearAlgebra` package.
If the matrices of an `AbstractKroneckerProduct` instance are square,
performs Eigenvalue decompositon on them and returns an `Eigen` type.
Otherwise, it collects the instance and runs eigen on the full matrix.
The functions, `\\`, `inv`, and `logdet` are overloaded to efficiently work
with this type.
"""
function eigen(K::AbstractKroneckerProduct; kw...)
    checksquare(K)
    A, B = getmatrices(K)
    if issquare(A) && issquare(B)
        A_λ, A_Γ = eigen(A; kw...)
        B_λ, B_Γ = eigen(B; kw...)
        return Eigen(kron(A_λ, B_λ), kronecker(A_Γ, B_Γ))
    else
        return eigen(Matrix(K); kw...)
    end
end

function LinearAlgebra.eigvals(K::AbstractKroneckerProduct; kw...)
    checksquare(K)
    A, B = getmatrices(K)
    if issquare(A) && issquare(B)
        λA = eigvals(A; kw...)
        λB = eigvals(B; kw...)
        λ = kron(λA, λB)
        # sort in lexicographic order by default
        sortby = get(kw, :sortby, x -> (real(x), imag(x)))
        if sortby !== nothing
            sort!(λ, by = sortby)
        end
        return λ
    else
        return eigvals(Matrix(K); kw...)
    end
end

+(E::Eigen, B::UniformScaling) = Eigen(E.values .+ B.λ, E.vectors)
+(A::UniformScaling, E::Eigen) = E + A

"""
    collect(E::Eigen{<:Number, <:Number, <:AbstractKroneckerProduct})

Collects eigenvalue decomposition of a `AbstractKroneckerProduct` type into a
matrix.
"""
function collect(E::Eigen{<:Number,<:Number,<:AbstractKroneckerProduct})
    λ, Γ = E
    return Γ * Diagonal(λ) * Γ'
end

function \(E::Eigen{<:Number,<:Number,<:AbstractKroneckerProduct}, v::AbstractVector{<:Number})
    λ, Γ = E
    return Γ * (Diagonal(λ) \ (Γ' * v))
end

"""
    logdet(K::Eigen)

Compute the logarithm of the determinant of the eigenvalue decomp of a Kronecker
product.
"""
logdet(E::Eigen{<:Number,<:Number,<:AbstractKroneckerProduct}) = sum(log, E.values)

"""
    inv(K::Eigen)

Compute the inverse of the eigenvalue decomp of a Kronecker product. Returns
another type of `Eigen`.
"""
inv(E::Eigen{<:Number,<:Number,<:AbstractKroneckerProduct}) = Eigen(inv.(E.values), E.vectors)

@inline _alloc_temp_array(size_1::Int, x::AbstractVector{T}) where {T} = similar(x, (size_1))
@inline _alloc_temp_array(size_1::Int, x::AbstractMatrix{T}) where {T} = similar(x, (size_1, size(x, 2)))

const MatrixOrFactorization{T} = Union{AbstractMatrix{T},Factorization{T}}

for N in (1, 2)
    for op in [:mul, :ldiv]
        square_kernel! = Symbol("_kron_", op, "_kernel_square!")

        op! = Symbol(op, "!")
        if N == 1
            op_expr_square = :(@views q[slc] = $op!(temp[1:n], m, q[slc]))
        else
            op_expr_square = :(@views q[slc, :] = $op!(temp[1:n, :], m, q[slc, :]))
        end

        @eval function $square_kernel!(temp::AbstractArray{T1,$N}, q::AbstractArray{T2,$N}, n::Int, i_left::Int, m::MatrixOrFactorization{T3}, i_right::Int) where {T1,T2,T3}
            # apply kron(I(l), m, I(r)) where m is square to the given vector x, overwriting x in the process

            if m isa Factorization || m isa Adjoint{T3,<:Factorization} || m isa Transpose{T3,<:Factorization} || m != I
                # if matrix is the identity, skip matmul/div, unless it's some sort factorization, then proceed anyway
                irc = i_right * n

                base_i, top_i = 0, (irc - i_right)
                @inbounds for i_l in 1:i_left
                    for i_r in 1:i_right
                        slc = base_i+i_r:i_right:top_i+i_r

                        $op_expr_square
                    end

                    base_i += irc
                    top_i += irc
                end
            end
            return q
        end

        square_func! = Symbol("_kron_", op, "_fast_square!")
        @eval function $square_func!(out::AbstractArray{T1,$N}, x::AbstractArray{T2,$N}, matrices) where {T1,T2}
            ns::Vector{Int} = [size(m, 1) for m in matrices]
            i_left::Int = 1
            i_right::Int = prod(ns)

            out = copyto!(out, x)
            temp = _alloc_temp_array(maximum(ns), x)

            for s in 1:length(ns)
                n = ns[s]
                i_right ÷= n
                $square_kernel!(temp, out, n, i_left, matrices[s], i_right)
                i_left *= n
            end
            return out
        end

        # NOTE: ldiv! seems to give erroneous results if m is not square,
        #       using allocating ldiv for now
        if N == 1
            if op == :mul
                op_expr_rect = :(@views q′[slc_out] = mul!(temp[1:r_h], m, q[slc_in]))
            else
                op_expr_rect = :(@views q′[slc_out] = m \ q[slc_in])
            end
        else
            if op == :mul
                op_expr_rect = :(@views q′[slc_out, :] = mul!(temp[1:r_h, :], m, q[slc_in, :]))
            else
                op_expr_rect = :(@views q′[slc_out, :] = m \ q[slc_in, :])
            end
        end

        rect_kernel! = Symbol("_kron_", op, "_kernel_rect!")
        @eval function $rect_kernel!(temp::AbstractArray{T1,$N}, q::AbstractArray{T2,$N}, r_h::Int, c_h::Int, i_left::Int, m::MatrixOrFactorization{T3}, i_right::Int) where {T1,T2,T3}
            # apply kron(I(i_left), m, I(i_right)) to the given vector q

            # don't bother checking for identity, since we know the matrix
            #  is rectangular here
            irc = i_right * c_h
            irr = i_right * r_h

            size_ = i_left * irr
            q′ = _alloc_temp_array(size_, q)

            base_i, base_j = 0, 0
            top_i, top_j = (irc - i_right), (irr - i_right)
            @inbounds for i_l in 1:i_left
                for i_r in 1:i_right
                    slc_in = base_i+i_r:i_right:i_r+top_i
                    slc_out = base_j+i_r:i_right:i_r+top_j

                    $op_expr_rect
                end

                base_i += irc
                top_i += irc

                base_j += irr
                top_j += irr
            end

            return q′
        end

        rect_func! = Symbol("_kron_", op, "_fast_rect!")
        ri = (op == :mul) ? 1 : 2
        ci = (op == :mul) ? 2 : 1
        @eval function $rect_func!(out::AbstractArray{T1,$N}, x::AbstractArray{T2,$N}, matrices) where {T1,T2}
            r::Vector{Int} = [size(m, $ri) for m in matrices]
            c::Vector{Int} = [size(m, $ci) for m in matrices]
            i_left::Int = 1
            i_right::Int = prod(c)

            out_ = copy(x)
            temp = _alloc_temp_array(maximum(r), x)

            for h in 1:length(matrices)
                r_h, c_h = r[h], c[h]
                i_right ÷= c_h
                if r_h == c_h
                    $square_kernel!(temp, out_, r_h, i_left, matrices[h], i_right)
                else
                    out_ = $rect_kernel!(temp, out_, r_h, c_h, i_left, matrices[h], i_right)
                end
                i_left *= r_h
            end

            out = copyto!(out, out_)
            return out
        end
    end

    @eval function _kronsum_mul_fast!(out::AbstractArray{T1,$N}, x::AbstractArray{T2,$N}, matrices) where {T1,T2}
        ns::Vector{Int} = [size(m, 1) for m in matrices]
        i_left::Int = 1
        i_right::Int = prod(ns)

        out = fill!(out, zero(T1))
        temp = copy(x)
        # should use similar instead, but there seems to be a bug when using copy! with empty SparseArrays
        small_temp = _alloc_temp_array(maximum(ns), x)

        # this loop is technically parallelizable,
        #  though that'd end up using more memory
        for s in 1:length(ns)
            n = ns[s]
            i_right ÷= n
            copyto!(temp, x)
            out += _kron_mul_kernel_square!(small_temp, temp, n, i_left, matrices[s], i_right)
            i_left *= n
        end
        return out
    end
end

#=
Created on Friday 26 July 2019
Last update: -

@author: Michiel Stock
michielfmstock@gmail.com

Standard matrix factorization algorithms applied on Kronecker systems.
=#


abstract type FactorizedKronecker{T} <: AbstractKroneckerProduct{T} end

# CHOLESKY DECOMPOSITION
# ----------------------

import LinearAlgebra: Cholesky, cholesky

struct CholeskyKronecker{T<:Union{Cholesky,FactorizedKronecker},S<:Union{Cholesky,FactorizedKronecker}} <: FactorizedKronecker{Float64}
    A::T
    B::S
end

issquare(C::Cholesky) = true

function Base.getproperty(C::CholeskyKronecker, d::Symbol)
    if d in [:U, :L, :UL]
        return kronecker(getproperty(C.A, d), getproperty(C.B, d))
    elseif d in [:A, :B]
        return getfield(C, d)
    else
        throw(ArgumentError("Attribute :$d not supported (only :A, :B, :UL, :U or :L)"))
    end
end

function Base.show(io::IO, mime::MIME{Symbol("text/plain")}, C::CholeskyKronecker)
    summary(io, C)
    println(io)
    println(io, "U factor:")
    show(io, mime, getproperty(C, :U))
end

"""
    cholesky(K::AbstractKroneckerProduct; check = true)

Wrapper around `cholesky` from the `LinearAlgebra` package. Performs Cholesky
on the matrices of a `AbstractKroneckerProduct` instances and returns a
`CholeskyKronecker` type. Similar to `Cholesky`, `size`, `\\`, `inv`, `det`,
and `logdet` are overloaded to efficiently work with this type.
"""
function cholesky(K::AbstractKroneckerProduct; check = true)
    checksquare(K)
    A, B = getmatrices(K)
    return CholeskyKronecker(cholesky(A, check = check),
        cholesky(B, check = check))
end

using Random, LinearAlgebra

# Standardised tests for the eigen decomposition of a square kronecker product
function eigen_tests(rng, C::AbstractKroneckerProduct)

    # Check approximate correctness of decomposition
    λ, Γ = eigen(C)
    @test Γ * Diagonal(λ) * Γ' ≈ C
    @test Γ * (Diagonal(λ) * Γ') ≈ C
    @test (Γ * Diagonal(λ)) * Γ' ≈ C

    # Check approximate correctness of shifted decomposition
    σ² = abs2(randn(rng))
    λ′, Γ′ = (eigen(C) + σ² * I)
    @test Γ′ * Diagonal(λ′) * Γ′' ≈ Matrix(C + σ² * I)
    @test σ² * I + C == C + σ² * I

    # Test with decomposition
    v = randn(rng, length(λ))
    @test eigen(C) \ v ≈ Float64.(Matrix(C)) \ v

    # Test various linear algebra operations with decomposition
    C_dense = Float64.(Matrix(C))
    @test det(eigen(C)) ≈ det(C_dense)
    @test logdet(eigen(C)) ≈ logdet(C_dense)
    @test Matrix(inv(eigen(C))) ≈ inv(C_dense)
end

@testset "eigen" begin
    rng, P, Q, R = MersenneTwister(123456), 3, 5, 7

    # Generate some positive definite matrices so that logdet can be tested.
    A_, B_, C_ = randn(rng, P, P), randn(rng, Q, Q), randn(rng, R, R)
    A, B, C = Symmetric(A_ * A_' + I), Symmetric(B_ * B_' + I), Symmetric(C_ * C_' + I)

    D = kronecker(A, B)
    eigen_tests(rng, D)
    eigen_tests(rng, kronecker(D, C))
    eigen_tests(rng, kronecker(C, D))
    eigen_tests(rng, kronecker(kronecker(A, B), kronecker(B, A)))
    eigen_tests(rng, kronecker(A, 4))

    function test_non_square_extension()
        local n, m, A, B, K, M
        n, m = 3, 5
        # 1. K is square, while A, B aren't
        A = randn(n, m)
        B = randn(m, n)
        K = A ⊗ B
        M = Matrix(K)
        E = eigen(K)
        F = eigen(M)
        @test E.values ≈ F.values
        @test det(E) ≈ det(F)
        @test Matrix(E) ≈ K

        # 2. K is not square
        A = randn(n, m)
        B = randn(m, m)
        K = A ⊗ B
        @test_throws DimensionMismatch eigen(K)
    end
    test_non_square_extension()
end

@testset "eigvals" begin
    A = rand(3,3); B = rand(4, 4);
    K = kronecker(A, B);
    Kd = kron(A, B);
    sort_lexicographic(v) = sort!(v, by = x -> (real(x), imag(x)))
    @test sort_lexicographic(eigvals(K)) ≈ sort_lexicographic(eigvals(Kd))
    if VERSION >= v"1.6"
        @test real(eigvals(K, sortby = real)) ≈ real(eigvals(Kd, sortby = real)) atol=1e-14 rtol=1e-8
    end
    A = rand(2,3); B = rand(3, 2);
    K = kronecker(A, B);
    Kd = kron(A, B);
    @test sort_lexicographic(eigvals(K)) ≈ sort_lexicographic(eigvals(Kd))
end

#=
Created on Saturday 3 August 2019
Last update: Thursday 8 August 2019

@author: Michiel Stock
michielfmstock@gmail.com

Some methods to simulate Kronecker graphs.

Leskovec, J., Chakrabarti, D., Kleinberg, J., Faloutsos, C., & Ghahramani,
Z. (2008). Kronecker graphs: an approach to modeling networks.
Journal of Machine Learning Research, 11, 985–1042.
Retrieved from https://cs.stanford.edu/~jure/pubs/kronecker-jmlr10.pdf
=#

using SparseArrays: spzeros
using StatsBase: sample, Weights

"""
    isprob(A::AbstractArray)

Test if a matrix can be interpeted as a probability matrix, i.e., all elements
are between 0 and 1.
"""
isprob(A::AbstractArray) = all(0 .<= A .<= 1)

"""
    isprob(K::AbstractKroneckerProduct)

Test if a Kronecker product can be interpeted as a probability matrix,
i.e., all elements are between 0 and 1.
"""
function isprob(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return isprob(A) && isprob(B)
end

"""
    naivesample(P::AbstractKroneckerProduct)

Sample a Kronecker graph from a probabilistic Kronecker product P using the
naive method. This method has a time complexity in the size of the Kronecker
product (but is still light in memory use). Consider using `fastsample`.
"""
function naivesample(P::AbstractKroneckerProduct)
    @assert isprob(P) throw(DomainError(
        "All values of K should be between 0 and 1"))
    G = spzeros(Bool, size(P)...)
    for I in CartesianIndices(P)
        if P[I] > rand()  # QUESTION: is this the most efficient way?
            @inbounds G[I] = true
        end
    end
    return G
end

"""
    sampleindices(A::AbstractMatrix, s::Int)

Samples the indices from an `AbstractMatrix`. Probability of sampling indices is
proportional to the size of the corresponding value. Does not do any checks on A.
"""
sampleindices(A::AbstractMatrix, s::Int) = Tuple.(sample(CartesianIndices(A),
    Weights(vec(A), sum(A)), s,
    replace = true))

"""
sampleindices(K::AbstractKroneckerProduct, s::Int)

Samples the indices from an `AbstractKroneckerProduct`. Probability of
sampling indices is proportional to the size of the corresponding value.
Does not do any checks on A.
"""
function sampleindices(K::AbstractKroneckerProduct, s::Int)
    A, B = getmatrices(K)
    p, q = size(B)
    indicesA = sampleindices(A, s)
    indicesB = sampleindices(B, s)
    indices = similar(indicesA)
    for (o, (Ia, Ib)) in enumerate(zip(indicesA, indicesB))
        (i, j), (k, l) = Ia, Ib
        @inbounds indices[o] = ((i - 1) * p + k, (j - 1) * q + l)
    end
    return indices
end

"""
    fastsample(P::AbstractKroneckerProduct)

Uses the heuristic sampling from Leskovec et al. (2008) to sample a large
Kronecker graph.
"""
function fastsample(P::AbstractKroneckerProduct)
    @assert isprob(P) throw(DomainError(
        "All values of K should be between 0 and 1"))
    G = spzeros(Bool, size(P)...)
    n = Int(round(sum(P)))  # expected number of edges
    for (i, j) in sampleindices(P, n)
        @inbounds G[i, j] = true
    end
    return G
end

module Kronecker

export GeneralizedKroneckerProduct, AbstractKroneckerProduct
export AbstractKroneckerSum, KroneckerSum
export KroneckerPower
export issquare, order, issymmetric, isposdef, getmatrices, collect!
export ⊗, kronecker, ⊕, kroneckersum
export CholeskyKronecker

export isprob, naivesample, fastsample, sampleindices

using LinearAlgebra
import LinearAlgebra: mul!, lmul!, rmul!, pinv, ldiv!
import Base: collect, *, getindex, size, eltype, inv, adjoint
using SparseArrays
using LinearAlgebra: checksquare, AbstractTriangular

include("base.jl")
include("kroneckerpowers.jl")
include("kroneckersum.jl")
include("multiply.jl")
include("vectrick.jl")
include("indexedkroncker.jl")
include("eigen.jl")
include("factorization.jl")
include("kroneckergraphs.jl")
include("names.jl")

end # module

using NamedDims

# Re-wrap with names:
kronecker(A::NamedDimsArray{L1}, B::NamedDimsArray{L2}) where {L1,L2} =
    NamedDimsArray(KroneckerProduct(parent(A), parent(B)), kron_names(L1, L2))

kronecker(A::NamedDimsArray{L}, B::AbstractMatrix) where {L} =
    NamedDimsArray(KroneckerProduct(parent(A), B), kron_names(L, (:_, :_)))
kronecker(A::AbstractMatrix, B::NamedDimsArray{L}) where {L} =
    NamedDimsArray(KroneckerProduct(A, parent(B)), kron_names((:_, :_), L))

# Power
kronecker(A::NamedDimsArray{L}, p::Int) where {L} =
    NamedDimsArray(kronecker(parent(A), p), kron_names(L, Val(p)))

# Finding the names
kron_names(left::Tuple, right::Tuple) = map(_join, left, right)

_join(i::Symbol, j::Symbol) = _join(Val(i), Val(j))
@generated _join(::Val{i}, ::Val{j}) where {i,j} = QuoteNode(Symbol(i, :ᵡ, j))

kron_names(L::Tuple, ::Val{1}) = L
kron_names(L::Tuple, ::Val{p}) where {p} = kron_names(kron_names(L, L), Val(p - 1))

#=
Created on Monday 12 August 2019
Last update: -

@author: Michiel Stock
michielfmstock@gmail.com

Efficient ways of storing Kronecker powers.
=#

"""
Efficient way of storing Kronecker powers, e.g.

K = A ⊗ A ⊗ ... ⊗ A.
"""
struct KroneckerPower{T,TA<:AbstractMatrix{T}} <: AbstractKroneckerProduct{T}
    A::TA
    pow::Int
    function KroneckerPower(A::AbstractMatrix, pow::Integer)
        @assert pow ≥ 2 "KroneckerPower only makes sense for powers greater than 1"
        return new{eltype(A),typeof(A)}(A, Int(pow))
    end
end

"""
    kronecker(A::AbstractMatrix, pow::Int)

Kronecker power, computes `A ⊗ A ⊗ ... ⊗ A`. Returns a lazy `KroneckerPower`
type.
"""
kronecker(A::AbstractMatrix, pow::Integer) = KroneckerPower(A, pow)

"""
    ⊗(A::AbstractMatrix, pow::Int)

Kronecker power, computes `A ⊗ A ⊗ ... ⊗ A`. Returns a lazy `KroneckerPower`
type.
"""
⊗(A::AbstractMatrix, pow::Integer) = kronecker(A, pow)

getallfactors(K::KroneckerPower) = ntuple(_ -> K.A, K.pow)

getmatrices(K::KroneckerPower) = (K.pow == 2 ? K.A : KroneckerPower(K.A, K.pow - 1), K.A)

lastmatrix(K::KroneckerPower) = K.A

Base.copy(K::KroneckerPower) = kronecker(copy(K.A), K.pow)
Base.deepcopy(K::KroneckerPower) = kronecker(deepcopy(K.A), K.pow)
Base.similar(K::KroneckerPower) = kronecker(similar(K.A), K.pow)

order(K::KroneckerPower) = K.pow
Base.size(K::KroneckerPower) = size(K.A) .^ K.pow
issquare(K::KroneckerPower) = issquare(K.A)

# SCALAR EQUIVALENTS FOR AbstractKroneckerProduct

"""
    det(K::KroneckerPower)

Compute the determinant of a Kronecker power.
"""
function LinearAlgebra.det(K::KroneckerPower)
    checksquare(K.A)
    A, pow = K.A, K.pow
    n = size(A, 1)
    return det(K.A)^(n * pow)
end

"""
    logdet(K::KroneckerPower)

Compute the logarithm of the determinant of a Kronecker power.
"""
function LinearAlgebra.logdet(K::KroneckerPower)
    checksquare(K.A)
    A, pow = K.A, K.pow
    n = size(A, 1)
    return n * pow * logdet(K.A)
end

"""
    tr(K::KroneckerPower)

Compute the trace of a Kronecker power.
"""
function LinearAlgebra.tr(K::KroneckerPower)
    checksquare(K.A)
    return tr(K.A)^K.pow
end

# Matrix operations

"""
    inv(K::KroneckerPower)

Compute the inverse of a Kronecker power.
"""
function Base.inv(K::KroneckerPower)
    checksquare(K.A)
    return KroneckerPower(inv(K.A), K.pow)
end


"""
    pinv(K::KroneckerPower)

Compute the Moore-Penrose pseudo-inverse of a Kronecker power.
"""
function LinearAlgebra.pinv(K::KroneckerPower)
    return KroneckerPower(pinv(K.A), K.pow)
end

function LinearAlgebra.diag(K::KroneckerPower)
    if issquare(K.A)
        d = reshape(diag(K.A), :, 1)
        return vec(reduce(kron, fill(d, order(K))))
    end
    return K[diagind(K)]
end

"""
    adjoint(K::KroneckerPower)

Compute the adjoint of a Kronecker power.
"""
function Base.adjoint(K::KroneckerPower)
    return KroneckerPower(K.A', K.pow)
end

"""
    transpose(K::KroneckerPower)

Compute the transpose of a Kronecker power.
"""
function Base.transpose(K::KroneckerPower)
    return KroneckerPower(transpose(K.A), K.pow)
end

"""
    conj(K::KroneckerPower)

Compute the conjugate of a Kronecker power.
"""
function Base.conj(K::KroneckerPower)
    return KroneckerPower(conj(K.A), K.pow)
end

# mixed-product property
function _mulmixed(K1::KroneckerPower, K2::KroneckerPower)
    if size(K1, 2) != size(K2, 1)
        throw(DimensionMismatch("Mismatch between K1 and K2"))
    end
    return KroneckerPower(K1.A * K2.A, K1.pow)
end
function Base.:*(K1::KroneckerPower, K2::KroneckerPower)
    K1.pow == K2.pow || throw(ArgumentError("multiplication is only defined if all terms have the same exponent"))
    _mulmixed(K1, K2)
end

const KronPowDiagonal = KroneckerPower{<:Any,<:Diagonal}
const KroneckerDiagonal = Union{KronProdDiagonal,KronPowDiagonal}

function Base.:*(K1::KronPowDiagonal, K2::KronPowDiagonal)
    K1.pow == K2.pow || throw(ArgumentError("multiplication is only defined if all terms have the same exponent"))
    _mulmixed(K1, K2)
end

for T in [:Diagonal, :UniformScaling]
    @eval Base.:+(K::KroneckerDiagonal, D::$T) = Diagonal(K) + D
    @eval Base.:+(D::$T, K::KroneckerDiagonal) = D + Diagonal(K)
    @eval Base.:-(K::KroneckerDiagonal, D::$T) = Diagonal(K) - D
    @eval Base.:-(D::$T, K::KroneckerDiagonal) = D - Diagonal(K)
end

Base.:+(K1::KroneckerDiagonal, K2::KroneckerDiagonal) = Diagonal(K1) + Diagonal(K2)
Base.:-(K1::KroneckerDiagonal, K2::KroneckerDiagonal) = Diagonal(K1) - Diagonal(K2)

"""
    lmul!(a::Number, K::KroneckerPower)

Scale an `KroneckerPower` `K` inplace by a factor `a` by rescaling the matrix the base
matrix with a factor `a^(1/N)`.

It is recommended to rewrite your Kronecker product rather as `copy(A) ⊗ (A ⊗ n - 1)`
(note the copy) for numerical stability. This will only modify the first matrix, leaving
the chain of Kronecker products alone.
"""
function LinearAlgebra.lmul!(a::Number, K::KroneckerPower)
    # will only work if eltype is some kind of float
    #eltype(K) <: AbstractFloat || throw(InexactError)
    n = order(K)
    @warn "Inplace scaling of a Kronecker product, consider rewriting as `copy(A) ⊗ (A ⊗ $n - 1)`"
    A = K.A
    lmul!(a^(1 / n), A)
end

using LinearAlgebra: cholesky

@testset "Factorization" begin
    @testset "Cholesky" begin
        A = [1 0 0.5;
             0 2 0;
             0.5 0 3]

        B = rand(4)
        B *= B'
        B += I

        K = A ⊗ B

        @test isposdef(K)

        KC = cholesky(K)
        @test isposdef(K)
        @test size(K) == (12, 12)

        C = cholesky(collect(K))

        @test det(KC) ≈ det(C)
        @test logdet(KC) ≈ logdet(C)
        @test collect(inv(KC)) ≈ inv(C)
    end
end

using Luxor
import Random
Random.seed!(123);

function draw_kronecker(A, B)

    K = kron(A, B)'

    n, m = size(K)

    tiles = Tiler(12.5n, 12.5m, m, n, margin=0)

    for ((pos, n), k) in zip(tiles, K)
        if k==1
            sethue(Luxor.darker_green)
        elseif k==2
            sethue(Luxor.darker_red)
        elseif k==3
            sethue(Luxor.darker_purple)
        else
            randomhue()
        end
        if k > 0
            circle(pos, 5, :fill)
        end
    end
end

A = [1 1 0 0;
    0 1 0 1;
    1 0 1 1;
    0 1 0 1]

A = rand(Bool, 6, 6)
B = rand([0, 0, 0, 0, 1, 2, 3], 10, 15)


@pdf draw_kronecker(A', B) 1500 1000 "poster.pdf"

A = rand([0, 0, 1], 10, 15)
B = collect(0:3)

@pdf draw_kronecker(B, A) 240 600 "rectanle.pdf"


B = [1 2 3; 2 1 3; 3 2 1]'
A = rand([0, 0, 1], 10, 10)

@png draw_kronecker(B', A) 600 600 "logo.png"

@testset "Indexed" begin
    v = rand(10)

    a, b = 4, 8
    c, d = 5, 9

    M = randn(a, b)
    N = rand(c, d)

    p = rand(1:a, 6)
    q = rand(1:c, 6)

    r = rand(1:b, 10)
    t = rand(1:d, 10)

    kronprod = N ⊗ M

    @test_throws DimensionMismatch kronprod[p, rand(1:b, 11), r,t]
    @test_throws BoundsError kronprod[p, -q, r,t]
    @test_throws BoundsError kronprod[p, q.+b, r,t]
    @test_throws BoundsError kronprod[p,q,r,t.+d]

    ikp = kronprod[p,q,r,t]

    @test eltype(ikp) == Float64

    subsystem = kron(N, M)[a * (q .- 1) .+ p, b * (t .- 1) .+ r]
    @test subsystem ≈ collect(ikp)
    @test subsystem ≈ ikp

    @test (N, M) == getmatrices(ikp)

    # result shortcut
    #u = genvectrick(M, N, v, p, q, r, t)
    u = ikp * v
    # result naive
    unaive = kron(N, M)[a * (q .- 1) .+ p, b * (t .- 1) .+ r] * v
    @test all(u .≈ unaive)

    @test_throws DimensionMismatch ikp * rand(8)
end

#=
Created on Tuesday 2 July 2019
Last update: Saturday 27 July 2019

@author: Michiel Stock
michielfmstock@gmail.com

Benchmarking Kroncker.jl compated to native functions.
=#

using Kronecker, Plots, LinearAlgebra
using BenchmarkTools


sizes = [5, 10, 25, 50, 100, 250, 500, 1000, 5000]

tmax = 10

# inverse

times_kron = []
times_naive = []

for s in sizes
    A = randn(s, s) / s^2
    B = rand(s, s) / s^2
    v = rand(s^2)
    K = A ⊗ B
    t = @belapsed inv($K)
    push!(times_kron, t)
    if s^2 < 5000
        K = collect(K)
        t = @belapsed inv($K)
        push!(times_naive, t)
        compute_naive = t < tmax
    end
end

plot(sizes.^2, times_kron, label="matrix inverse", color=:blue, legend=:bottomright, lw=2)
plot!(sizes[1:length(times_naive)].^2, times_naive, color=:blue, ls=:dash, label="", lw=2 )


# determinant

times_kron = []
times_naive = []

@belapsed det(Kwarmup)

for s in sizes
    A = randn(s, s)
    B = rand(s, s)
    v = rand(s^2)
    K = A ⊗ B
    t = @belapsed det($K)
    push!(times_kron, t)
    if s^2 < 5000
        K = collect(K)
        t = @belapsed det($K)
        push!(times_naive, t)
        compute_naive = t < tmax
    end
end

plot!(sizes.^2, times_kron, label="determinant", color=:green, lw=2)
plot!(sizes[1:length(times_naive)].^2, times_naive, color=:green, ls=:dash, label="", lw=2)

# squaring

times_kron = []
times_naive = []

v = rand(100)

@belapsed Kwarmup * Kwarmup

for s in sizes
    A = randn(s, s)
    B = rand(s, s)
    v = rand(s^2)
    K = A ⊗ B
    t = @belapsed $K * $K
    push!(times_kron, t)
    if s^2 < 5000
        K = collect(K)
        t = @belapsed $K * $K
        push!(times_naive, t)
        compute_naive = t < tmax
    end
end

plot!(sizes.^2, times_kron, label="squaring", color=:red, lw=2)
plot!(sizes[1:length(times_naive)].^2, times_naive, color=:red, ls=:dash, label="", lw=2)

# vector multiplication

times_kron = []
times_naive = []

for s in sizes
    A = randn(s, s)
    B = rand(s, s)
    v = rand(s^2)
    K = A ⊗ B
    t = @belapsed $K * $v
    push!(times_kron, t)
    if s^2 < 5000
        K = collect(K)
        t = @belapsed $K * $v
        push!(times_naive, t)
        compute_naive = t < tmax
    end
end

plot!(sizes.^2, times_kron, label="matrix-vector mult.", color=:orange, lw=2)
plot!(sizes[1:length(times_naive)].^2, times_naive, color=:orange, ls=:dash, label="", lw=2)


yaxis!(:log10)
ylabel!("CPU time (s)")
xaxis!(:log10)
xlabel!("Kronecker product size")
title!("Performance Kronecker.jl (-) vs. native code (--)")

savefig("benchmark.svg")

abstract type GeneralizedKroneckerProduct{T} <: AbstractMatrix{T} end

Base.eltype(K::GeneralizedKroneckerProduct{T}) where {T} = T

abstract type AbstractKroneckerProduct{T} <: GeneralizedKroneckerProduct{T} end

Base.IndexStyle(::Type{<:GeneralizedKroneckerProduct}) = IndexCartesian()

"""
    collect!(C::AbstractMatrix, K::GeneralizedKroneckerProduct)

In-place collection of `K` in `C`. If possible, specialized routines are used to
speed up the computation. The fallback is an element-wise iteration. In this case,
this function might be slow.
"""
function collect!(C::AbstractMatrix, K::GeneralizedKroneckerProduct)
    size(C) == size(K) || throw(DimensionMismatch("`K` $(size(K)) cannot be collected in `C` $(size(C))"))
    @inbounds for I in CartesianIndices(K)
        C[I] = K[I]
    end
    return C
end


"""
    collect(K::GeneralizedKroneckerProduct)

Collects a lazy instance of the `GeneralizedKroneckerProduct` type into a dense,
native matrix. Falls back to the element-wise case when not specialized method
is defined.
"""
function collect(K::GeneralizedKroneckerProduct{T}) where {T}
    C = Matrix{T}(undef, size(K)...)
    collect!(C, K)
    return C
end


"""
    KroneckerProduct{T,TA<:AbstractMatrix, TB<:AbstractMatrix} <: AbstractKroneckerProduct{T}

Concrete Kronecker product between two matrices `A` and `B`.
"""
struct KroneckerProduct{T<:Any,TA<:AbstractMatrix,TB<:AbstractMatrix} <: AbstractKroneckerProduct{T}
    A::TA
    B::TB
    function KroneckerProduct(A::AbstractMatrix{T}, B::AbstractMatrix{V}) where {T,V}
        return new{promote_type(T, V),typeof(A),typeof(B)}(A, B)
    end
end

# conversion
Base.convert(::Type{T}, K::KroneckerProduct) where {T<:KroneckerProduct} = K isa T ? K : T(K)
function KroneckerProduct{T,TA,TB}(K::KroneckerProduct) where {T,TA,TB}
    A, B = getmatrices(K)
    KroneckerProduct(convert(TA, A), convert(TB, B))
end

"""
    kronecker(A::AbstractMatrix, B::AbstractMatrix)

Construct a Kronecker product object between two arrays. Does not evaluate the
Kronecker product explictly.
"""
kronecker(A::AbstractMatrix, B::AbstractMatrix) = KroneckerProduct(A, B)

# version that have a vector as input reshape to matrices
kronecker(A::AbstractVector, B::AbstractMatrix) = KroneckerProduct(reshape(A, :, 1), B)
kronecker(A::AbstractMatrix, B::AbstractVector) = KroneckerProduct(A, reshape(B, :, 1))
kronecker(A::AbstractVector, B::AbstractVector) = KroneckerProduct(reshape(A, :, 1), reshape(B, :, 1))

"""
    kronecker(A::AbstractMatrix, B::AbstractMatrix)

Higher-order Kronecker lazy kronecker product, e.g.
```
kronecker(A, B, C, D)
```
"""
kronecker(A::AbstractVecOrMat, B::AbstractVecOrMat...) = kronecker(A,
    kronecker(B...))


kronecker(A::AbstractVecOrMat) = A

"""
    ⊗(A::AbstractMatrix, B::AbstractMatrix)

Binary operator for `kronecker`, computes as Lazy Kronecker product. See
`kronecker` for documentation.
"""
⊗(A::AbstractVecOrMat, B::AbstractVecOrMat) = kronecker(A, B)
⊗(A::AbstractVecOrMat...) = kronecker(A...)

"""
    getindex(K::AbstractKroneckerProduct, i1::Integer, i2::Integer)

Computes and returns the (i,j)-th element of an `AbstractKroneckerProduct` K.
Uses recursion if `K` is of an order greater than two.
"""
function getindex(K::AbstractKroneckerProduct, i1::Integer, i2::Integer)
    A, B = getmatrices(K)
    k, l = size(B)
    return (A[cld(i1, k), cld(i2, l)]::eltype(A)) * (B[(i1-1)%k+1, (i2-1)%l+1]::eltype(B))
end


"""
    getallfactors(K::AbstractKroneckerProduct)

Obtain all factors in an `AbstractKroneckerProduct` object.
"""
getallfactors(K::AbstractKroneckerProduct) = (getallfactors(K.A)..., getallfactors(K.B)...)
getallfactors(K::AbstractMatrix) = (K,)


"""
    getmatrices(K::AbstractKroneckerProduct)

Obtain the two matrices of an `AbstractKroneckerProduct` object.
"""
getmatrices(K::AbstractKroneckerProduct) = (K.A, K.B)

"""
    getmatrices(A::AbstractArray)

Returns a matrix itself. Needed for recursion.
"""
getmatrices(A::AbstractArray) = (A,)

firstmatrix(K::AbstractKroneckerProduct) = first(getmatrices(K))
lastmatrix(K::AbstractKroneckerProduct) = last(getmatrices(K))

"""
    size(K::AbstractKroneckerProduct)

Returns a the size of an `AbstractKroneckerProduct` instance.
"""
function size(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    (m, n) = size(A)
    (k, l) = size(B)
    return m * k, n * l
end

"""
    size(K::GeneralizedKroneckerProduct)

Returns a the size of an `GeneralizedKroneckerProduct` instance.
"""
size(K::GeneralizedKroneckerProduct, dim::Integer) = size(K)[dim]

Base.copy(K::AbstractKroneckerProduct) = kronecker(copy(K.A), copy(K.B))
Base.deepcopy(K::AbstractKroneckerProduct) = kronecker(deepcopy(K.A), deepcopy(K.B))
Base.copy!(K1::AbstractKroneckerProduct, K2::AbstractKroneckerProduct) = begin
	  Base.copy!(K1.A, K2.A)
	  Base.copy!(K1.B, K2.B)
    return K1
end

Base.similar(K::AbstractKroneckerProduct) = kronecker(similar(K.A), similar(K.B))

# CHECKS

"""
    issquare(A::AbstractMatrix)

Checks if an array is a square matrix.
"""
function issquare(A::AbstractMatrix)
    m, n = size(A)
    return m == n
end


"""
    issquare(A::Factorization)

Checks if a Factorization struct represents a square matrix.
"""
function issquare(A::Factorization)
    m, n = size(A)
    return m == n
end

"""
    issymmetric(K::AbstractKroneckerProduct)

Checks if a Kronecker product is symmetric.
"""
function LinearAlgebra.issymmetric(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return issymmetric(A) && issymmetric(B)
end


"""
    ishermitian(K::AbstractKroneckerProduct)

Checks if a Kronecker product is Hermitian.
"""
function LinearAlgebra.ishermitian(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return ishermitian(A) && ishermitian(B)
end

"""
    isposdef(K::AbstractKroneckerProduct)

Test whether a Kronecker product is positive definite (and Hermitian) by trying
to perform a Cholesky factorization of K.
"""
function LinearAlgebra.isposdef(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return isposdef(A) && isposdef(B)
end

# SCALAR PROPERTIES

"""
    order(M::AbstractMatrix)

Returns the order of a matrix, i.e. how many matrices are involved in the
Kronecker product (default to 1 for general matrices).
"""
order(M::AbstractMatrix) = 1
order(M::AbstractKroneckerProduct) = order(M.A) + order(M.B)

"""
    det(K::AbstractKroneckerProduct)

Compute the determinant of a Kronecker product.
"""
function LinearAlgebra.det(K::AbstractKroneckerProduct{T}) where {T}
    checksquare(K)
    A, B = getmatrices(K)
    if issquare(A) && issquare(B)
        m = size(A)[1]
        n = size(B)[1]
        return det(A)^n * det(B)^m
    else
        return zero(T)
    end
end

"""
    logdet(K::AbstractKroneckerProduct)

Compute the logarithm of the determinant of a Kronecker product.
"""
function LinearAlgebra.logdet(K::AbstractKroneckerProduct{T}) where {T}
    checksquare(K)
    A, B = getmatrices(K)
    if issquare(A) && issquare(B)
        m = size(A)[1]
        n = size(B)[1]
        return n * logdet(A) + m * logdet(B)
    else
        return real(T)(-Inf)
    end
end

"""
    tr(K::AbstractKroneckerProduct)

Compute the trace of a Kronecker product.
"""
function LinearAlgebra.tr(K::AbstractKroneckerProduct)
    checksquare(K)
    A, B = getmatrices(K)
    if issquare(A) && issquare(B)
        return tr(A) * tr(B)
    else
        return sum(diag(K))
    end
end

"""
    inv(K::AbstractKroneckerProduct)

Compute the inverse of a Kronecker product.
"""
function inv(K::AbstractKroneckerProduct)
    checksquare(K)
    A, B = getmatrices(K)
    if issquare(A) && issquare(B)
        return KroneckerProduct(inv(A), inv(B))
    else
        throw(SingularException(1))
    end
end

"""
    pinv(K::AbstractKroneckerProduct)

Compute the Moore-Penrose pseudo-inverse of a Kronecker product.
"""
function LinearAlgebra.pinv(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return KroneckerProduct(pinv(A), pinv(B))
end

"""
    adjoint(K::AbstractKroneckerProduct)

Compute the adjoint of a Kronecker product.
"""
function adjoint(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return kronecker(A', B')
end

"""
    transpose(K::AbstractKroneckerProduct)

Compute the transpose of a Kronecker product.
"""
function Base.transpose(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return kronecker(transpose(A), transpose(B))
end

function Base.permutedims(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return kronecker(permutedims(A), permutedims(B))
end

function Base.conj(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return kronecker(conj(A), conj(B))
end

function LinearAlgebra.diag(K::KroneckerProduct)
    A, B = getmatrices(K)
    if issquare(A) && issquare(B)
        return kron(diag(K.A), diag(K.B))
    end
    return K[diagind(K)]
end

# COLLECTING

#=
"""
    collect(K::AbstractKroneckerProduct)

Collects a lazy instance of the `AbstractKroneckerProduct` type into a full,
native matrix. Equivalent with `Matrix(K::AbstractKroneckerProduct)`.
"""
function collect(K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    return kron(A, B)
end
=#

_maybecollect(A::GeneralizedKroneckerProduct) = collect(A)
_maybecollect(A::AbstractArray) = A

# function for in-place Kronecker product
function _kron!(C::AbstractArray, A::AbstractArray, B::AbstractArray)
    m = first(LinearIndices(C)) - 1
    @inbounds for j = axes(A, 2), l = axes(B, 2), i = axes(A, 1)
        Aij = A[i, j]
        for k = axes(B, 1)
            C[m+=1] = Aij * B[k, l]
        end
    end
    return C
end

_kron!(C::AbstractArray, A::GeneralizedKroneckerProduct, B::AbstractArray) = _kron!(C, collect(A), B)
_kron!(C::AbstractArray, A::AbstractArray, B::GeneralizedKroneckerProduct) = _kron!(C, A, collect(B))
_kron!(C::AbstractArray, A::GeneralizedKroneckerProduct, B::GeneralizedKroneckerProduct) = _kron!(C, collect(A), collect(B))

@inline function _kron!(C::AbstractArray, As::Tuple{AbstractArray,Vararg{AbstractArray}}, Bs::Tuple{AbstractArray,Vararg{AbstractArray}}, f = identity)
    m = first(LinearIndices(C)) - 1
    A1 = first(As)
    B1 = first(Bs)
    for j = axes(A1, 2), l = axes(B1, 2), i = axes(A1, 1)
        Aijs = map(A -> A[i, j], As)
        for k = 1:size(Bs[1], 1)
            Bkls = map(B -> B[k, l], Bs)
            Aijs_times_Bkls = map(*, Aijs, Bkls)
            C[m+=1] = f(Aijs_times_Bkls...)
        end
    end
    return C
end

"""
    collect!(C::AbstractMatrix, K::AbstractKroneckerProduct)

In-place collection of `K` in `C` where `K` is an `AbstractKroneckerProduct`, i.e.,
`K = A ⊗ B`. This is equivalent to the broadcasted assignment `C .= K`.

    collect!(f, C::AbstractMatrix, K1::AbstractKroneckerProduct, Ks::AbstractKroneckerProduct...)

Evaluate `f.(K1, Ks...)` and assign it in-place to `C`. This is equivalent to the broadcasted
operation `C .= f.(K1, Ks...)`.
"""
function collect!(C::AbstractMatrix, K::AbstractKroneckerProduct)
    size(C) == size(K) || throw(DimensionMismatch("`K` $(size(K)) cannot be collected in `C` $(size(C))"))
    A, B = getmatrices(K)
    return _kron!(C, A, B)
end

@inline function collect!(f, C::AbstractMatrix, K1::AbstractKroneckerProduct, Ks::AbstractKroneckerProduct...)
    @noinline throwdm(K1sz, Csz) = throw(DimensionMismatch("`K` $K1sz cannot be collected in `C` $Csz"))
    size(C) == size(K1) || throwdm(size(K1), size(C))
    for K in Ks
        size(C) == size(K) || throwdm(size(K), size(C))
    end
    Ks_all = (K1, Ks...)
    As = map(x -> first(getmatrices(x)), Ks_all)
    Bs = map(x -> last(getmatrices(x)), Ks_all)
    return _kron!(C, As, Bs, f)
end

"""
    Matrix(K::GeneralizedKroneckerProduct)

Converts a `GeneralizedKroneckerProduct` instance to a Matrix type.
"""
Base.Matrix(K::GeneralizedKroneckerProduct) = collect(K)

function Base.:+(A::AbstractKroneckerProduct, B::StridedMatrix)
    T = promote_type(eltype(A), eltype(B))
    C = convert(Matrix{T}, collect(A))
    C .+= B
    return C
end
Base.:+(A::StridedMatrix, B::AbstractKroneckerProduct) = B + A

function Base.:+(A::AbstractKroneckerProduct, B1::AbstractKroneckerProduct, Brest::AbstractKroneckerProduct...)
    Bs = (B1, Brest...)
    for B in Bs
        Base.promote_shape(A, B) # check size compatibility
    end
    # special methods to handle kronecker products with singleton matrices
    # if one matrix is common to all products, we only need to add the other matrix
    if all(x -> firstmatrix(x) === firstmatrix(A), Bs)
        K1 = kronecker(firstmatrix(A), +(lastmatrix(A), map(lastmatrix, Bs)...))
        return collect(K1)
    elseif all(x -> lastmatrix(x) === lastmatrix(A), Bs)
        K2 = kronecker(+(firstmatrix(A), map(firstmatrix, Bs)...), lastmatrix(A))
        return collect(K2)
    end
    # if the sizes of the component matrices are compatible, the operation may be
    # short-circuited
    sa = map(size, getmatrices(A))
    if all(x -> map(size, getmatrices(x)) == sa, Bs)
        return broadcast(+, A, Bs...)
    end
    # collect the arrrays before adding to avoid indexing into the kronecker products
    Ac = collect(A)
    broadcast!(+, Ac, Ac, map(collect, Bs)...)
    return Ac
end

function Base.:-(A::AbstractKroneckerProduct, B::StridedMatrix)
    T = promote_type(eltype(A), eltype(B))
    C = convert(Matrix{T}, collect(A))
    C .-= B
    return C
end
function Base.:-(A::StridedMatrix, B::AbstractKroneckerProduct)
    T = promote_type(eltype(A), eltype(B))
    C = similar(Array{T}, size(A))
    @. C = -B
    C .+= A
    return C
end

# some tricks to preferentially negate structured matrices
supportsfastnegation(::AbstractMatrix) = false
supportsfastnegation(::Union{Diagonal,Bidiagonal,Tridiagonal,SymTridiagonal}) = true
supportsfastnegation(A::AbstractKroneckerProduct) = all(supportsfastnegation, getmatrices(A))

function Base.:-(K::AbstractKroneckerProduct)
    B = lastmatrix(K)
    supportsfastnegation(B) && return kronecker(firstmatrix(K), -B)
    return kronecker(-firstmatrix(K), B)
end

const KronProdDiagonal = KroneckerProduct{<:Any,<:Diagonal,<:Diagonal}
for T in [:Diagonal, :UniformScaling]
    @eval Base.:+(K::KronProdDiagonal, D::$T) = Diagonal(K) + D
    @eval Base.:+(D::$T, K::KronProdDiagonal) = D + Diagonal(K)
    @eval Base.:-(K::KronProdDiagonal, D::$T) = Diagonal(K) - D
    @eval Base.:-(D::$T, K::KronProdDiagonal) = D - Diagonal(K)
end

function Base.:-(A::AbstractKroneckerProduct, B::AbstractKroneckerProduct)
    # special methods to handle kronecker products with singleton matrices
    # if one matrix is common to all products, we only need to add the other matrix
    if firstmatrix(B) === firstmatrix(A)
        K1 = kronecker(firstmatrix(A), lastmatrix(A) - lastmatrix(B))
        return collect(K1)
    elseif lastmatrix(B) === lastmatrix(A)
        K2 = kronecker(firstmatrix(A) - firstmatrix(B), lastmatrix(A))
        return collect(K2)
    end
    # if the sizes of the component matrices are compatible, the operation may be
    # short-circuited
    if map(size, getmatrices(A)) == map(size, getmatrices(B))
        return A .- B
    end
    # collect the arrrays before subtracting to avoid indexing into the kronecker products
    Ac = collect(A)
    Ac .-= collect(B)
    return Ac
end

function Base.kron(K::AbstractKroneckerProduct, C::AbstractMatrix)
    A, B = getmatrices(K)
    return kron(kron(A, B), C)
end

function Base.kron(A::AbstractMatrix, K::AbstractKroneckerProduct)
    B, C = getmatrices(K)
    return kron(A, kron(B, C))
end

Base.kron(K1::AbstractKroneckerProduct,
    K2::AbstractKroneckerProduct) = kron(collect(K1), collect(K2))

# mixed-product property
function Base.:*(K1::AbstractKroneckerProduct, K2::AbstractKroneckerProduct)
    A, B = getmatrices(K1)
    C, D = getmatrices(K2)
    # check for size
    if size(A, 2) != size(C, 1)
        throw(DimensionMismatch("Mismatch between A and C in (A ⊗ B)(C ⊗ D)"))
    end
    if size(B, 2) != size(D, 1)
        throw(DimensionMismatch("Mismatch between B and D in (A ⊗ B)(C ⊗ D)"))
    end
    return (A * C) ⊗ (B * D)
end


"""
    lmul!(a::Number, K::AbstractKroneckerProduct)

Scale an `AbstractKroneckerProduct` `K` inplace by a factor `a` by rescaling the
**left** matrix.
"""
function LinearAlgebra.lmul!(a::Number, K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    lmul!(a, A)
end

"""
    rmul!(K::AbstractKroneckerProduct, a::Number)

Scale an `AbstractKroneckerProduct` `K` inplace by a factor `a` by rescaling the
**right** matrix.
"""
function LinearAlgebra.rmul!(K::AbstractKroneckerProduct, a::Number)
    A, B = getmatrices(K)
    rmul!(B, a)
end

function Base.:*(a::Number, K::AbstractKroneckerProduct)
    A, B = getmatrices(K)
    kronecker(a * A, B)
end


function Base.:*(K::AbstractKroneckerProduct, a::Number)
    A, B = getmatrices(K)
    kronecker(A, B * a)
end

function LinearAlgebra.power_by_squaring(K::KroneckerProduct, p::Integer)
    A, B = getmatrices(K)
    kronecker(A^p, B^p)
end

function LinearAlgebra.svdvals(K::KroneckerProduct)
    A, B = getmatrices(K)
    σA = svdvals(A)
    σB = svdvals(B)
    σ = sort!(kron(σA, σB), rev = true)
    n = minimum(size(K))
    if length(σ) < n
        append!(σ, zeros(eltype(σ), n - length(σ)))
    end
    return σ
end

# Special method to construct a kronecker product of Diagonals
# See https://github.com/MichielStock/Kronecker.jl/pull/113#issuecomment-1024920775
"""
    diagonal(A::AbstractMatrix)

Construct a diagonal matrix with the principal diagonal being `diag(A)`.
"""
diagonal(A::AbstractMatrix) = Diagonal(A)
function diagonal(K::AbstractKroneckerProduct)
    mats = getmatrices(K)
    if !all(issquare, mats)
        throw(ArgumentError(
            "Kronecker product of non-square matrices provided, " *
            "consider using LinearAlgbera.Diagonal instead"))
    end
    mapreduce(diagonal, ⊗, mats)
end

# Broadcasting machinery

Base.copyto!(dest::AbstractMatrix, K::AbstractKroneckerProduct) = collect!(dest, K)

struct AbsKronProdStyle <: Broadcast.AbstractArrayStyle{2} end
AbsKronProdStyle(::Val{N}) where {N} = Broadcast.DefaultArrayStyle{N}()
AbsKronProdStyle(::Val{2}) = AbsKronProdStyle()

Base.BroadcastStyle(::Type{<:AbstractKroneckerProduct}) = AbsKronProdStyle()

function Base.similar(bc::Broadcast.Broadcasted{AbsKronProdStyle}, ::Type{T}) where {T}
    similar(Array{T}, axes(bc))
end

@inline function Base.copyto!(dest::AbstractArray, bc::Broadcast.Broadcasted{AbsKronProdStyle})
    @noinline throwdm(axdest, axsrc) =
        throw(DimensionMismatch("destination axes $axdest are not compatible with source axes $axsrc"))
    axes(dest) == axes(bc) || throwdm(axes(dest), axes(bc))
    # Some common cases that may be short-circuited
    # Case 1, example: A .= B
    if bc.args isa Tuple{AbstractKroneckerProduct}
        A = bc.args[1]
        collect!(bc.f, dest, A)
        return dest
    # Case 2, example: 2 .* B
    elseif bc.args isa Tuple{Number,AbstractKroneckerProduct}
        A = last(bc.args)
        n = first(bc.args)
        collect!(let n = n
            x -> bc.f(n, x)
        end, dest, A)
        return dest
    # Case 3, example: B .* 2
    elseif bc.args isa Tuple{AbstractKroneckerProduct,Number}
        A = first(bc.args)
        n = last(bc.args)
        collect!(let n = n
            x -> bc.f(x, n)
        end, dest, A)
        return dest
    end
    # An operation like K1 .+ K2 may be short-circuited if the component matrices
    # have the same size.
    bcf = Broadcast.flatten(bc)
    if all(x -> x isa AbstractKroneckerProduct, bcf.args)
        sz1 = map(size, getmatrices(bcf.args[1]))
        if all(x -> map(size, getmatrices(x)) == sz1, bcf.args[2:end])
            collect!(bcf.f, dest, bcf.args...)
            return dest
        end
    elseif all(x -> x isa Union{AbstractKroneckerProduct,StridedArray}, bcf.args)
        # Performance is better if the kronecker products are collected before the
        # broadcasted operation is performed, although this incurs allocations
        broadcast!(bcf.f, dest, map(_maybecollect, bcf.args)...)
        return dest
    end
    # The general case that indexes into each array.
    # This may be slow as indexing into an AbstractKroneckerProduct is expensive
    bc′ = Broadcast.preprocess(dest, bc)
    # Performance may vary depending on whether `@inbounds` is placed outside the
    # for loop or not. (cf. https://github.com/JuliaLang/julia/issues/38086)
    @inbounds @simd for I in eachindex(bc′)
        dest[I] = bc′[I]
    end
    return dest
end

abstract type AbstractKroneckerSum{T} <: GeneralizedKroneckerProduct{T} end

struct KroneckerSum{T<:Any,TA<:AbstractMatrix,TB<:AbstractMatrix} <: AbstractKroneckerSum{T}
    A::TA
    B::TB
    function KroneckerSum(A::AbstractMatrix{T},
        B::AbstractMatrix{V}) where {T,V}
        (issquare(A) && issquare(B)) || throw(DimensionMismatch(
            "KroneckerSum only applies to square matrices"))
        return new{promote_type(T, V),typeof(A),typeof(B)}(A, B)
    end
end

Base.copy(K::KroneckerSum) = kroneckersum(copy(K.A), copy(K.B))
Base.deepcopy(K::KroneckerSum) = kroneckersum(deepcopy(K.A), deepcopy(K.B))
Base.similar(K::KroneckerSum) = kroneckersum(similar(K.A), similar(K.B))
Base.copy!(K1::KroneckerSum, K2::KroneckerSum) = begin
    Base.copy!(K1.A, K2.A)
    Base.copy!(K1.B, K2.B)
    return K1
end

order(M::AbstractKroneckerSum) = order(M.A) + order(M.B)
issquare(M::AbstractKroneckerSum) = true

"""
    kroneckersum(A::AbstractMatrix, B::AbstractMatrix)

Construct a sum of Kronecker products between two square matrices and their
respective identity matrices. Does not evaluate the Kronecker products
explicitly.
"""
kroneckersum(A::AbstractMatrix, B::AbstractMatrix) = KroneckerSum(A, B)

"""
    kroneckersum(A::AbstractMatrix, B::AbstractMatrix...)

Higher-order lazy kronecker sum, e.g.
```
kroneckersum(A,B,C,D)
```
"""
kroneckersum(A::AbstractMatrix, B::AbstractMatrix...) = kroneckersum(A, kroneckersum(B...))

"""
    kroneckersum(A::AbstractMatrix, pow::Int)

Kronecker-sum power, computes
`A ⊕ A ⊕ ... ⊕ A = (A ⊗ I ⊗ ... ⊗ I) + (I ⊗ A ⊗ ... ⊗ I) + ... (I ⊗ I ⊗ ... A)`.
"""
function kroneckersum(A::AbstractMatrix, pow::Int)
    @assert pow > 0 "Works only with positive powers!"
    if pow == 1
        return A
    else
        return A ⊕ kroneckersum(A, pow - 1)
    end
end


"""
    ⊕(A::AbstractMatrix, B::AbstractMatrix)

Binary operator for `kroneckersum`, computes as Lazy Kronecker sum. See `kroneckersum` for
documentation.
"""
⊕(A::AbstractMatrix, B::AbstractMatrix) = kroneckersum(A, B)
⊕(A::AbstractMatrix...) = kroneckersum(A...)
⊕(A::AbstractMatrix, pow::Int) = kroneckersum(A, pow)


"""
    getallsummands(K::T) where T <: AbstractKroneckerSum

Obtain the all summands of an `AbstractKroneckerSum` object.
"""
getallsummands(K::AbstractKroneckerSum) = (getallsummands(K.A)..., getallsummands(K.B)...)
getallsummands(K::AbstractArray) = (K,)

"""
    getmatrices(K::T) where T <: AbstractKroneckerSum

Obtain the two matrices of an `AbstractKroneckerSum` object.
"""
Kronecker.getmatrices(K::AbstractKroneckerSum) = (K.A, K.B)

function Base.size(K::AbstractKroneckerSum)
    A, B = getmatrices(K)
    (m, n) = size(A)
    (k, l) = size(B)
    return m * k, n * l
end

Base.size(K::AbstractKroneckerSum, dim::Int) = size(K)[dim]

function Base.getindex(K::AbstractKroneckerSum, i1::Int, i2::Int)
    A, B = getmatrices(K)
    k, l = size(B)
    i₁, j₁ = cld(i1, k), cld(i2, l)
    i₂, j₂ = (i1 - 1) % k + 1, (i2 - 1) % l + 1
    v = zero(eltype(K))
    if i₁ == j₁
        v += B[i₂, j₂]
    end
    if i₂ == j₂
        v += A[i₁, j₁]
    end
    return v
end

function Base.eltype(K::AbstractKroneckerSum)
    A, B = getmatrices(K)
    return promote_type(eltype(A), eltype(B))
end

"""
    collect!(C::AbstractMatrix, K::AbstractKroneckerSum)

In-place collection of `K` in `C` where `K` is an `AbstractKroneckerSum`, i.e.,
`K = A ⊗ B`.
"""
function collect!(C::AbstractMatrix, K::AbstractKroneckerSum)
    fill!(C, zero(eltype(C)))
    A, B = getmatrices(K)
    A, B = sparse(A), sparse(B)
    IA, IB = oneunit(A), oneunit(B)
    C .+= kron(A, IB)
    C .+= kron(IA, B)
end

function LinearAlgebra.tr(K::AbstractKroneckerSum)
    A, B = getmatrices(K)
    n, m = size(A, 1), size(B, 1)
    return m * tr(A) + n * tr(B)
end

"""
    collect(K::AbstractKroneckerSum)

Collects a lazy instance of the `AbstractKroneckerSum` type into a full,
native matrix. Returns the result as a sparse matrix.
"""
function Base.collect(K::AbstractKroneckerSum)
    A, B = getmatrices(sparse(K))
    IA, IB = oneunit(A), oneunit(B)
    return kron(A, IB) .+ kron(IA, B)
end

"""
    SparseArrays.sparse(K::KroneckerSum)

Creates a lazy instance of a `KroneckerSum` type with sparse
matrices. If the matrices are already sparse, `K` is returned.
"""
function SparseArrays.sparse(K::KroneckerSum{T,TA,TB}) where {T,TA<:AbstractSparseMatrix,TB<:AbstractSparseMatrix}
    return K
end

function SparseArrays.sparse(K::KroneckerSum{T,TA,TB}) where {T,TA<:AbstractMatrix,TB<:AbstractMatrix}
    return sparse(K.A) ⊕ sparse(K.B)
end

"""
    SparseArrays.issparse(K::AbstractKroneckerSum)

Checks if both matrices of an `AbstractKroneckerSum` are sparse.
"""
function SparseArrays.issparse(K::AbstractKroneckerSum)
    return issparse(K.A) && issparse(K.B)
end

function Base.kron(K::AbstractKroneckerSum, C::AbstractMatrix)
    return kron(collect(K), C)
end

function Base.kron(A::AbstractMatrix, K::AbstractKroneckerSum)
    return kron(A, collect(K))
end

function Base.kron(K1::AbstractKroneckerSum, K2::AbstractKroneckerSum)
    return kron(collect(K1), collect(K2))
end

function Base.adjoint(K::AbstractKroneckerSum)
    A, B = getmatrices(K)
    return kroneckersum(A', B')
end

function Base.transpose(K::AbstractKroneckerSum)
    A, B = getmatrices(K)
    return kroneckersum(transpose(A), transpose(B))
end

function Base.conj(K::AbstractKroneckerSum)
    A, B = getmatrices(K)
    return kroneckersum(conj(A), conj(B))
end

"""
    exp(K::AbstractKroneckerSum)

Computes the matrix exponential of an `AbstractKroneckerSum` `K`. Returns an
instance of `KroneckerProduct`.
"""
function Base.exp(K::AbstractKroneckerSum)
    A, B = getmatrices(K)
    return kronecker(exp(A), exp(B))
end

function Base.sum(K::KroneckerSum; dims::Union{Int,Nothing} = nothing)
    A, B = getmatrices(K)
    n, m = size(A, 1), size(B, 1)
    if dims == 1
        return kron(sum(A, dims = 1), ones(1, m)) .+ kron(ones(1, n), sum(B, dims = 1))
    elseif dims == 2
        return kron(sum(A, dims = 2), ones(m, 1)) .+ kron(ones(n, 1), sum(B, dims = 2))
    elseif dims isa Nothing
        m * sum(A) + n * sum(B)
    else
        throw(ArgumentError("`dims` should be 1 or 2"))
    end
end


#=
function Base.:*(K1::AbstractKroneckerSum, K2::AbstractKroneckerSum)

    # Collect products (not matrices)
    A, B = (K1.A, K1.B)
    C, D = (K2.A, K2.B)

    size.(getmatrices(A)) == size.(getmatrices(C)) || throw(DimensionMismatch("Mismatch between A and C in (A ⊗ B)(C ⊗ D)"))
    size.(getmatrices(B)) == size.(getmatrices(D)) || throw(DimensionMismatch("Mismatch between B and D in (A ⊗ B)(C ⊗ D)"))

    # Dimensions are also checked in src/base.jl
    return A*C + A*D + B*C + B*D
end
=#

#=
using Pkg

tmp_packages = ["Kronecker", "Documenter"]

push!(LOAD_PATH,"../src/")

Pkg.activate(".")

Pkg.add.(tmp_packages) # IMPORTANT
=#

using Documenter, Kronecker, LinearAlgebra

makedocs(
    sitename = "Kronecker.jl",
    authors = "Michiel Stock",
    format = Documenter.HTML(),
    modules = [Kronecker],
    pages = Any[
        "Basic use" => "man/basic.md",
        "Types" => "man/types.md",
        "Multiplication" => "man/multiplication.md",
        "Factorization methods" => "man/factorization.md",
        "Indexed Kronecker products" => "man/indexed.md",
        "Kronecker sums" => "man/kroneckersums.md",
        "Kronecker powers and graphs" => "man/kroneckerpowers.md"
    ]
)

deploydocs(
    repo = "github.com/MichielStock/Kronecker.jl.git",
)

@testset "Kronecker powers" begin
    A = [0.1 0.4; 0.6 2.1]
    B = [1 2 3 4; 5 6 7 8]

    K1 = kronecker(A, 3)
    K2 = kronecker(B, 3)

    K1dense = kron(A, A, A)
    K2dense = kron(B, B, B)

    C = [1 2; 3 4]
    KC = kronecker(C, 3)
    KCdense = kron(C, C, C)

    @testset "Types and basic properties" begin

        @test K1 isa AbstractKroneckerProduct
        @test K1 isa KroneckerPower

        @test issquare(K1)
        @test !issquare(K2)

        @test eltype(K1) <: Real
        @test eltype(K2) <: Integer

        @test order(K1) == 3

        @test getmatrices(K1)[1] isa KroneckerPower
        @test getmatrices(K1)[2] === A
        @test order(getmatrices(K1)[1]) == 2

        # scaling
        @test 3K1 ≈ 3K1dense ≈ K1 * 3
        @test 9.2 * K2 ≈ 9.2K2dense ≈ K2 * 9.2

        @test !issymmetric(K1)

        @test collect(K1) ≈ K1dense
        @test collect!(similar(K2dense), K2) ≈ K2dense

        @test sum(K1) ≈ sum(K1dense)

        @test copy(K2) isa KroneckerPower

        Kcopy = deepcopy(K2)
        @test Kcopy ≈ K2
        @test Kcopy isa KroneckerPower

        @test similar(K2) isa KroneckerPower

    end

    @testset "Inplace scaling" begin
        using LinearAlgebra: lmul!
        K1copy = kronecker(copy(A), 3)
        K2copy = kronecker(copy(B), 3)

        lmul!(2.7, K1copy)
        @test_throws InexactError lmul!(2.3, K2copy)

        @test K1copy ≈ 2.7K1dense

    end

    @testset "Linear algebra" begin
        @test tr(K1) ≈ tr(K1dense)
        @test !isposdef(K1)
        @test transpose(K1) ≈ transpose(K1dense)
        @test conj(K1) ≈ conj(K1dense)
        @test K1' ≈ K1dense'
        @test inv(K1) ≈ inv(K1dense)

        @test diag(K1) ≈ diag(K1dense)
        @test diag(K2) == diag(K2dense)
        @test diag(KC) == diag(KCdense)


        # test on pos def functions
        As = A' * A
        @test det(⊗(As, 2)) ≈ det(kron(As, As))
        @test logdet(⊗(As, 2)) ≈ log(det(kron(As, As)))
    end


    @testset "Inference in indexing" begin
        @test (@inferred K2[1,1]) == K2dense[1,1]
    end

    @testset "Arithmetic" begin
        @test K2 + K2 == 2 * K2 == 2 * K2dense
        @test K2 + K2 + K2 == 3 * K2 == 3 * K2dense
        @test K2 - K2 == 0 * K2 == 0 * K2dense
        @test K2 - K2 - K2 == -K2 == -K2dense
    end

    @testset "Broadcasting" begin
        @test K2 .+ K2 == 2 .* K2 == 2 .* K2dense
        @test K2 .- K2 == 0 .* K2 == 0 .* K2dense
        @test sin.(K2) == sin.(K2dense)
    end

    @testset "Multiplication" begin
        # product between two Kronecker powers
        @test K1 * K2 ≈ K1dense * K2dense
        # power
        @test K1^4 ≈ K1dense^4
        # mixed product
        @test K1 * (A ⊗ B ⊗ A) ≈ (A ⊗ A ⊗ A) * (A ⊗ B ⊗ A)
        @test (A ⊗ B' ⊗ A) * K1 ≈ (A ⊗ B' ⊗ A) * (A ⊗ A ⊗ A)
    end


@testset "Mixed product" begin

    @test K1 * K2 ≈ K1dense * K2dense
end

end

using NamedDims
@testset "named" begin
    A = rand(Int8, 2, 2)
    B = rand(Int8, 3, 3)
    ndA = NamedDimsArray(A, (:ia, :ja))
    ndB = NamedDimsArray(B, (:ib, :jb))

    @test NamedDims.dimnames(kronecker(ndA, ndB)) == (Symbol("iaᵡib"), Symbol("jaᵡjb"))
    @test NamedDims.dimnames(kronecker(ndA, B)) == (Symbol("iaᵡ_"), Symbol("jaᵡ_"))
    @test NamedDims.dimnames(kronecker(A, ndB)) == (Symbol("_ᵡib"), Symbol("_ᵡjb"))

    sum(abs2, kronecker(ndA, ndB) .- kron(A, B)) == 0

    @test 0 == @allocated Kronecker._join(:i, :j)
    @test 0 == @allocated Kronecker.kron_names((:ia, :ja), (:ib, :jb))

    @test NamedDims.dimnames(kronecker(ndA, 3)) == (Symbol("iaᵡiaᵡiaᵡia"), Symbol("jaᵡjaᵡjaᵡja"))
    @test 0 == @allocated Kronecker.kron_names((:i, :j), Val(3))
end

@testset "sums" begin

    A = rand(10, 10)
    B = rand(Bool, 5, 5)
    C = randn(10, 10)
    D = rand(1:10, 5, 5)

    KA = A ⊗ B
    KB = C ⊗ D

    K = KA + KB
    Kdense = kron(A, B) .+ kron(C, D)

    v = randn(50)
    V = randn(50, 3)

    @test K ≈ Kdense
    @test size(K) == size(Kdense)
    @test collect(K) ≈ Kdense
    @test sum(K) ≈ sum(Kdense)
    @test sum(K, dims=1) ≈ sum(Kdense, dims=1)
    @test K' ≈ Kdense'
    @test transpose(K) ≈ transpose(Kdense)
    @test conj(K) ≈ conj(Kdense)

    @test K * v ≈ Kdense * v
    @test K * V ≈ Kdense * V

    @test 5 * K ≈ 5 * Kdense
    @test K * 2.1 ≈ Kdense * 2.1

    # recursive, kronecker products of Kronecker sums


    
    Kl = (KA + KB) ⊗ C
    Kr = C ⊗ (KA + KB)
    Kb = ((B ⊗ C) + (B ⊗ C)) ⊗ ((B ⊗ C) + (B ⊗ C))
    
    #=
    Kl = kronecker(KA + KB, C)
    Kr = kronecker(C, KA + KB) 
    Kb = kronecker(kronecker(B, C) + kronecker(B, C), kronecker(B, C) + kronecker(B, C)) 
    =#

    n = size(Kl, 2)
    m = size(Kb, 2)

    v = randn(n)
    u = randn(m)

    
    @test Kl * v ≈ collect(Kl) * v
    @test Kr * v ≈ collect(Kr) * v
    @test Kb * u ≈ collect(Kb) * u
    


end

using Kronecker
using BenchmarkTools

SUITE = BenchmarkGroup()

SUITE["mul_vec"] = BenchmarkGroup(["vector", "multiplication"])
SUITE["mul_mat"] = BenchmarkGroup(["matrix", "multiplication"])
SUITE["ldiv_vec"] = BenchmarkGroup(["vector", "solve"])
SUITE["ldiv_mat"] = BenchmarkGroup(["matrix", "solve"])

###############################################################################

for k in keys(SUITE)
    SUITE[k]["all_square"] = BenchmarkGroup()
end

KProd = kronecker([randn(2,2) for i in 1:10]...)
KPow = kronecker(randn(2,2), 10)
KSum = kroneckersum([randn(2,2) for i in 1:10]...)
x = randn(2^10)

SUITE["mul_vec"]["all_square"]["KroneckerProduct"] = @benchmarkable ($KProd * $x)
SUITE["mul_vec"]["all_square"]["KroneckerPower"] = @benchmarkable ($KPow * $x)
SUITE["mul_vec"]["all_square"]["KroneckerSum"] = @benchmarkable ($KSum * $x)
SUITE["ldiv_vec"]["all_square"]["KroneckerProduct"] = @benchmarkable ($KProd \ $x)
SUITE["ldiv_vec"]["all_square"]["KroneckerPower"] = @benchmarkable ($KPow \ $x)
SUITE["ldiv_vec"]["all_square"]["KroneckerSum"] = @benchmarkable ($KSum \ $x)

###############################################################################

for k in keys(SUITE)
    SUITE[k]["all_rectangular"] = BenchmarkGroup()
end

KProd = kronecker([randn(3,2) for i in 1:10]...)
KPow = kronecker(randn(3,2), 10)
y = randn(3^10)

SUITE["mul_vec"]["all_rectangular"]["KroneckerProduct"] = @benchmarkable ($KProd * $x)
SUITE["mul_vec"]["all_rectangular"]["KroneckerPower"] = @benchmarkable ($KPow * $x)
SUITE["ldiv_vec"]["all_rectangular"]["KroneckerProduct"] = @benchmarkable ($KProd \ $y)
SUITE["ldiv_vec"]["all_rectangular"]["KroneckerPower"] = @benchmarkable ($KPow \ $y)

###############################################################################

for k in keys(SUITE)
    SUITE[k]["mixed_squareness"] = BenchmarkGroup()
end

KP = kronecker([randn(2,2) for i in 1:5]..., [randn(3,2) for i in 1:5]...)
x = randn(2^10)
y = randn((2^5)*(3^5))

SUITE["mul_vec"]["mixed_squareness"]["KroneckerProduct"] = @benchmarkable ($KP * $x)
SUITE["ldiv_vec"]["mixed_squareness"]["KroneckerProduct"] = @benchmarkable ($KP \ $y)

#=
Created on Saturday 3 August 2019
Last update: -

@author: Michiel Stock
michielfmstock@gmail.com

Vec trick: multiplying vectors with Kronecker systems.
=#


import Base.ReshapedArray

vectrick_reshape(v::AbstractVector, d::Int, b::Int) = reshape(v, d, b)
function vectrick_reshape(v::ReshapedArray{<:Any,1}, d::Int, b::Int)
    return size(v.parent) == (d, b) ? v.parent : reshape(v, d, b)
end


"""
    mul_vec_trick!(x::AbstractVector, K::AbstractKroneckerProduct, v::AbstractVector)

Calculates the vector-matrix multiplication `K * v` and stores the result in
`x`, overwriting its existing value.
"""
function mul_vec_trick!(x::AbstractVector, A::AbstractKroneckerProduct, v::AbstractVector)
    M, N = getmatrices(A)
    a, b = size(M)
    c, d = size(N)

    V = vectrick_reshape(v, d, b)
    X = vectrick_reshape(x, c, a)
    if b * c * (a + d) < a * d * (b + c)
        mul!(X, N, V * transpose(M))
    else
        mul!(X, N * V, transpose(M))
    end
    return x
end

function mul_vec_trick!(x::AbstractVector, K::AbstractKroneckerSum, v::AbstractVector)
    A, B = getmatrices(K)
    a, b = size(A)
    c, d = size(B)

    V = reshape(v, d, b)
    X = reshape(x, c, a)
    mul!(X, V, transpose(A))
    _mul5!(X, B, V, true, true)
    return x
end

if VERSION < v"1.3.0-alpha.115"
    function _mul5!(X, B, V, α, β)
        if β && α
            X .= (B * V) .* α .+ X .* β
        elseif α
            X .= (B * V) .* α
        elseif β
            X .*= β
        else
            X .= zero(eltype(X))
        end
    end
else # 5-arg mul! is available
    _mul5! = mul!
end # VERSION

function mul_vec_trick!(X::AbstractMatrix, A::GeneralizedKroneckerProduct, V::AbstractMatrix)
    @inbounds for i in eachindex(axes(X, 2), axes(V, 2))
        @views mul_vec_trick!(X[:, i], A, V[:, i])
    end
    return X
end


# SOLVING
function ldiv_vec_trick!(x::AbstractVector, A::AbstractKroneckerProduct, v::AbstractVector)
    M, N = getmatrices(A)
    b, a = size(M)
    d, c = size(N)
    e = length(v)
    f = length(x)

    V = vectrick_reshape(v, d, b)
    X = vectrick_reshape(x, c, a)
    if b * c * (a + d) < a * d * (b + c)
        S = N \ V
        copyto!(transpose(X), M \ transpose(S))
    else
        S = M \ transpose(V)
        copyto!(X, N \ transpose(S))
    end
    return x

    # size(K, 1) != length(v) && throw(DimensionMismatch("size(K, 1) != length(v)"))
    # C = reshape(v, size(K.B, 1), size(K.A, 1)) # matricify
    # return vec((K.B \ C) / K.A') #(A ⊗ B)vec(X) = vec(C) <=> BXA' = C => X = B^{-1} C A'^{-1}
end

function ldiv_vec_trick!(X::AbstractMatrix, A::AbstractKroneckerProduct, V::AbstractMatrix)
    @inbounds for i in eachindex(axes(X, 2), axes(V, 2))
        @views ldiv_vec_trick!(X[:, i], A, V[:, i])
    end
    return X
end


function check_compatible_sizes(C::AbstractVecOrMat, A::AbstractMatrix, B::AbstractVecOrMat, mul = true)
    # when performing a division (mul=false), A acts as a matrix with reversed dimensions
    m, n = mul ? size(A) : reverse(size(A))

    if n != size(B, 1)
        throw(DimensionMismatch(
            "A has size $(size(A)), B has size $(size(B))"
        ))
    elseif size(C) != (m, size(B)[2:end]...)
        throw(DimensionMismatch(
            "A has size $(size(A)), B has size $(size(B)), C has size $(size(C))"
        ))
    end
end

function mul!(C::AbstractMatrix, A::AbstractKroneckerProduct, D::Diagonal)
    check_compatible_sizes(C, A, D)
    @inbounds for j in axes(C, 2)
        @views C[:, j] = A[:, j] * D[j, j]
    end
    return C
end
function mul!(C::AbstractMatrix, D::Diagonal, A::AbstractKroneckerProduct)
    check_compatible_sizes(C, D, A)
    @inbounds for i in axes(C, 1)
        @views C[i, :] = D[i, i] * A[i, :]
    end
    return C
end
# disambiguation
mul!(C::AbstractMatrix, A::AbstractKroneckerProduct, B::LinearAlgebra.AbstractTriangular) =
    invoke(mul!, Tuple{AbstractMatrix, AbstractKroneckerProduct, AbstractMatrix}, C, A, B)

for TC in [:AbstractVector, :AbstractMatrix],
    TB in [:($TC), :(Transpose{T,<:$TC{T}} where {T}), :(Adjoint{T,<:$TC{T}} where {T})]

    @eval function mul!(C::$TC, A::AbstractKroneckerProduct, B::$TB)
        check_compatible_sizes(C, A, B)

        factors = getallfactors(A)

        if length(factors) == 2
            return mul_vec_trick!(C, A, B)
        elseif all(issquare, factors)
            return _kron_mul_fast_square!(C, B, factors)
        else
            return _kron_mul_fast_rect!(C, B, factors)
        end
    end

    @eval function ldiv!(C::$TC, A::AbstractKroneckerProduct, B::$TB)
        check_compatible_sizes(C, A, B, false)

        matrices = getallfactors(A)

        # TODO: should figure out how to avoid this if possible, leave
        #       factorization up to the user/Julia
        factors = ntuple(length(matrices)) do i
            m = matrices[i]
            return (m isa Factorization) ? m : unscalar(factorize(m))
        end

        if length(factors) == 2
            return ldiv_vec_trick!(C, A, B)
        elseif all(issquare, factors)
            return _kron_ldiv_fast_square!(C, B, factors)
        else
            return _kron_ldiv_fast_rect!(C, B, factors)
        end
    end

    @eval function mul!(C::$TC, A::AbstractKroneckerSum, B::$TB)
        check_compatible_sizes(C, A, B)

        summands = getallsummands(A)

        if length(summands) == 2
            return mul_vec_trick!(C, A, B)
        else
            return _kronsum_mul_fast!(C, B, summands)
        end
    end
end

# Utility function to handle factorize(one_by_one)::Number
unscalar(n::Number) = [n;;]
unscalar(x) = x

function Base.:*(K::GeneralizedKroneckerProduct, v::AbstractVector)
    return mul!(Vector{promote_type(eltype(v), eltype(K))}(undef, first(size(K))), K, v)
end

# explicit list of types that need to be disambiguated against
const MulMatTypes = [:Diagonal, :AbstractTriangular]

for T in [MulMatTypes; :AbstractMatrix]
    @eval function Base.:*(K::GeneralizedKroneckerProduct, M::$T)
        return mul!(Matrix{promote_type(eltype(M), eltype(K))}(undef, size(K, 1), size(M, 2)), K, M)
    end
end
for T in MulMatTypes
    @eval function Base.:*(M::$T, K::GeneralizedKroneckerProduct)
        return mul!(Matrix{promote_type(eltype(K), eltype(M))}(undef, size(M, 1), size(K, 2)), M, K)
    end
end

function Base.:*(v::AbstractMatrix, K::GeneralizedKroneckerProduct)
    out = Matrix{promote_type(eltype(v), eltype(K))}(undef, last(size(K)), first(size(v)))
    return transpose(mul!(out, transpose(K), collect(transpose(v))))
end

function Base.:*(v::Adjoint{<:Number,<:AbstractVector}, K::GeneralizedKroneckerProduct)
    out = Vector{promote_type(eltype(v), eltype(K))}(undef, last(size(K)))
    return mul!(out, K', v.parent)'
end

function Base.:*(v::Transpose{<:Number,<:AbstractVector}, K::GeneralizedKroneckerProduct)
    out = Vector{promote_type(eltype(v), eltype(K))}(undef, last(size(K)))
    return transpose(mul!(out, transpose(K), v.parent))
end

# special multiplication methods for Kronecker products of Diagonal matrices
# It's usually better to convert these to Diagonal to use optimized multiplication methods
# instead of using the vec trick
Base.:*(K::KroneckerDiagonal, v::AbstractVector) = Diagonal(K) * v
for T in MulMatTypes
    @eval Base.:*(K::KroneckerDiagonal, D::$T) = Diagonal(K) * D
    @eval Base.:*(D::$T, K::KroneckerDiagonal) = D * Diagonal(K)
end
# ambiguity fix
#Base.:*(K1::KroneckerDiagonal, K2::KroneckerDiagonal) = Diagonal(K1) * Diagonal(K2)

for T in [:Adjoint, :Transpose]
    @eval Base.:*(A::$T{<:Number,<:AbstractVector}, K::KroneckerDiagonal) = A * Diagonal(K)
end

function LinearAlgebra.:\(K::AbstractKroneckerProduct, v::AbstractVector)
    return ldiv!(Vector{promote_type(eltype(v), eltype(K))}(undef, last(size(K))), K, v)
end

function LinearAlgebra.:\(K::AbstractKroneckerProduct, v::AbstractMatrix)
    return ldiv!(Matrix{promote_type(eltype(v), eltype(K))}(undef, last(size(K)), last(size(v))), K, v)
end

function Base.sum(K::AbstractKroneckerProduct; dims::Union{Nothing,Int} = nothing)
    A, B = getmatrices(K)
    if dims === nothing
        s = zero(eltype(K))
        sumB = sum(B)
        return sum(sumB * A)
    else
        return kronecker(sum(A, dims = dims), sum(B, dims = dims))
    end
end

Index = AbstractVector{I} where {I<:Integer}

struct IndexedKroneckerProduct{T<:Any,TK<:AbstractKroneckerProduct} <: GeneralizedKroneckerProduct{T}
    K::TK
    p
    q
    r
    t
    function IndexedKroneckerProduct(K::AbstractKroneckerProduct, p::Index, q::Index, r::Index,
        t::Index)
        if order(K) != 2
            throw(DimensionMismatch(
                "Indexed Kronecker only implemented for second order Kronecker systems"
            ))
        elseif !(length(p) == length(q) && length(r) == length(t))
            throw(DimensionMismatch("Indices should have matching lengths"))
        elseif minimum((minimum.((p, q, r, t)))) <= 0
            throw(BoundsError("Nonpositive indices not allowed"))
        end
        A, B = getmatrices(K)
        (m, n) = size(B)
        (k, l) = size(A)
        if !(maximum(p) ≤ m && maximum(q) ≤ k)
            throw(BoundsError("Indices exeed matrix bounds"))
        end
        if !(maximum(r) ≤ n && maximum(t) ≤ l)
            throw(BoundsError("Indices exeed matrix bounds"))
        end
        return new{eltype(K),typeof(K)}(K, p, q, r, t)
    end
end

# Best way to do multi-line strings?

_dm(str) = throw(DimensionMismatch(str))
_ibe(str) = throw(BoundsError(str))

getindices(K::IndexedKroneckerProduct) = K.p, K.q, K.r, K.t

getmatrices(K::IndexedKroneckerProduct) = getmatrices(K.K)

Base.size(K::IndexedKroneckerProduct) = (length(K.p), length(K.t))

function Base.getindex(K::IndexedKroneckerProduct, i::Int, j::Int)
    A, B = getmatrices(K)
    p, q, r, t = getindices(K)
    return B[p[i], r[j]] * A[q[i], t[j]]
end

function Base.getindex(K::AbstractKroneckerProduct, p::Index, q::Index, r::Index, t::Index)
    return IndexedKroneckerProduct(K, p, q, r, t)
end

Base.eltype(K::IndexedKroneckerProduct) = eltype(K.K)

function Base.collect(K::IndexedKroneckerProduct)
    f, e = size(K)
    Kexplicit = Array{eltype(K)}(undef, f, e)
    N, M = getmatrices(K.K)
    p = K.p
    q = K.q
    r = K.r
    t = K.t
    for h in 1:f, g in 1:e
        Kexplicit[h, g] = N[q[h], t[g]] * M[p[h], r[g]]
    end
    return Kexplicit
end

function genvectrick!(M, N, v, u, p, q, r, t)
    # computes N ⊗ M

    a, b = size(M)
    c, d = size(N)
    e = length(v)
    f = length(u)

    @assert maximum(p) ≤ a && maximum(q) ≤ c
    @assert maximum(r) ≤ b && maximum(t) ≤ d
    u .= 0  # reset for inplace
    if a * e + d * f < c * e + b * f
        # compute T = VM'
        T = similar(v, (d, a))
        @simd for h in 1:e
            i, j = r[h], t[h]
            @simd for k in 1:a
                @inbounds T[j, k] += v[h] * M[k, i]
            end
        end
        @simd for h in 1:f
            i, j = p[h], q[h]
            @simd for k in 1:d
                @inbounds u[h] += N[j, k] * T[k, i]
            end
        end
    else
        # compute S = NV
        S = similar(v, (d, a))
        @simd for h in 1:e
            i, j = r[h], t[h]
            @simd for k in 1:c
                @inbounds S[k, j] += v[h] * N[k, j]
            end
        end
        @simd for h in 1:f
            i, j = p[h], q[h]
            @simd for k in 1:b
                @inbounds u[h] += S[j, k] * M[i, k]
            end
        end
    end
    return u
end

function genvectrick(M, N, v, p, q, r, t)
    # computes N ⊗ M
    f = length(p)
    u = similar(v, (f))
    return genvectrick!(M, N, v, u, p, q, r, t)
end

function Base.:*(K::IndexedKroneckerProduct, v::AbstractVector)
    if length(v) != size(K, 2)
        throw(DimensionMismatch(string(
            "Size indexed Kronecker system ($(size(K))) does not ",
            "match vector size ($(size(v)))",
        )))
    end
    N, M = getmatrices(K.K)
    p, q, r, t = getindices(K)
    return genvectrick(M, N, v, p, q, r, t)
end

A = rand(3, 3) + 1e-2I
B = ones(Int, 4, 4) + I
C = randn(5, 6)
K = A ⊗ B
X = collect(K)
v = rand(12)

K3 = A ⊗ B ⊗ C

@testset "multiply" begin
    @testset "Compatibility with other matrix ops" begin
        K = rand(3, 3) ⊗ randn(4, 4)
        K3 = rand(3, 3) ⊗ randn(4, 4) ⊗ randn(5, 6)
        KPow = kronecker(randn(3, 3), 3)

        for op in [adjoint, transpose, inv, pinv, conj]
            @test collect(op(K)) ≈ op(collect(K))
            if op != inv
                @test collect(op(K3)) ≈ op(collect(K3))
            else
                @test_throws DimensionMismatch op(K3)
            end
        end
    end

    @testset "Compatibility with Matrix Product" begin
        A_f = [randn(3, 4), randn(5, 6)]
        B_f = [randn(4, 2), randn(6, 7)]

        A = kronecker(A_f...)
        B = kronecker(B_f...)

        @test collect(A * B) ≈ collect(kronecker(map(*, A_f, B_f)...))

        C = randn(3, 3)
        D = randn(3, 2)
        C_pow = kronecker(C, 3)
        D_pow = kronecker(D, 3)
        @test collect(C_pow * D_pow) ≈ collect(kronecker(C * D, 3))

        @test_throws DimensionMismatch (D_pow * C_pow)
    end

    @testset "Vec trick" begin

        @test K * v ≈ X * v

        V = rand(4, 3)
        @test K * vec(V) ≈ X * vec(V)
        @test_throws DimensionMismatch K * V
        @test_throws DimensionMismatch K * reshape(V, 2, 6)

        v3 = randn(size(K3, 2))
        @test K3 * v3 ≈ collect(K3) * v3
        u = similar(v)
        @test mul!(u, K, v) ≈ X * v
    end

    @testset "Reshaped vec trick" begin
        @test K * v ≈ X * v

        V = sprand(4, 3, 1.0)
        @test K * vec(V) ≈ X * vec(V)
        @test_throws DimensionMismatch K * V
        @test_throws DimensionMismatch K * reshape(V, 2, 6)
        K3 = A ⊗ B ⊗ C
        v3 = sprand(size(K3, 2), 1.0)
        @test K3 * vec(v3) ≈ collect(K3) * v3
        u = similar(v)
        @test mul!(u, K, v) ≈ X * v

    end

    @testset "AbstractKroneckerProduct * AbstractMatrix" begin
        rng = MersenneTwister(123456)
        a, b, x = randn(rng, 30, 20), randn(rng, 40, 50), randn(rng, 1000, 1100)

        @test kron(a, b) * x ≈ (a ⊗ b) * x
        @test kron(a, Matrix(I, 50, 50)) * x ≈ (a ⊗ Matrix(I, 50, 50)) * x
        @test kron(Matrix(I, 20, 20), b) * x ≈ (Matrix(I, 20, 20) ⊗ b) * x
    end

    @testset "sum" begin
        @test sum(K) ≈ sum(X)
        @test sum(K3) ≈ sum(collect(K3))

        @test sum(K, dims = 1) ≈ sum(X, dims = 1)
        @test sum(K3, dims = 2) ≈ sum(collect(K3), dims = 2)
        @test sum(K3, dims = 2) isa AbstractKroneckerProduct

        @test sum(kronecker(A, 3)) ≈ sum(kron(A, A, A))
    end

    @inline function compare_against_kron(K, k, x, X, y, Y)
        @test collect(K) ≈ k

        res1 = (K * x)
        res2 = (K * X)
        @test res1 ≈ (k * x)
        @test res2 ≈ (k * X)

        if K isa AbstractKroneckerProduct
            res3 = (K \ y)
            res4 = (K \ Y)
            @test res3 ≈ (k \ y)
            @test res4 ≈ (k \ Y)
        end

        if size(K, 1) == size(x, 1)
            res1a = (x' * K)
            res1t = (transpose(x) * K)

            @test res1a ≈ (x' * k)
            @test res1t ≈ (transpose(x) * k)
            @test (K' * x) ≈ (k' * x) ≈ res1a'
            @test (transpose(K) * x) ≈ (transpose(k) * x) ≈ transpose(res1t)
        else
            @test_throws DimensionMismatch (x' * K)
            @test_throws DimensionMismatch (transpose(x) * K)
        end

        if size(K, 1) == size(X, 1)
            res2a = (X' * K)
            res2t = (transpose(X) * K)

            @test res2a ≈ (X' * k)
            @test res2t ≈ (transpose(X) * k)
            @test (K' * X) ≈ (k' * X) ≈ res2a'
            @test (transpose(K) * X) ≈ (transpose(k) * X) ≈ transpose(res2t)
        else
            @test_throws DimensionMismatch (X' * K)
            @test_throws DimensionMismatch (transpose(X) * K)
        end

    end

    @testset "2-factor square KroneckerProduct" begin
        A = randn(10, 10)
        B = randn(7, 7)
        x = randn(size(A, 2) * size(B, 2))
        X = randn(size(A, 2) * size(B, 2), 4)
        y = randn(size(A, 1) * size(B, 1))
        Y = randn(size(A, 1) * size(B, 1), 4)

        K1 = kronecker(A, B)
        K2 = kronecker(B, A)
        KS = kroneckersum(A, B)

        k1 = kron(A, B)
        k2 = kron(B, A)
        ks = kron(A, Diagonal(I, size(B, 1))) + kron(Diagonal(I, size(A, 1)), B)

        for (K, k) in [(K1, k1), (K2, k2), (KS, ks)]
            compare_against_kron(K, k, x, X, y, Y)
        end
    end


    @testset "2-factor rectangular KroneckerProduct" begin
        A = randn(10, 8)
        B = randn(7, 9)
        x = randn(size(A, 2) * size(B, 2))
        X = randn(size(A, 2) * size(B, 2), 4)
        y = randn(size(A, 1) * size(B, 1))
        Y = randn(size(A, 1) * size(B, 1), 4)

        K1 = kronecker(A, B)
        K2 = kronecker(B, A)
        k1 = kron(A, B)
        k2 = kron(B, A)

        for (K, k) in [(K1, k1), (K2, k2)]
            compare_against_kron(K, k, x, X, y, Y)
        end
    end


    @testset "3-factor rectangular KroneckerProduct" begin
        A = randn(10, 8)
        B = randn(7, 9)
        C = randn(6, 4)
        x = randn(size(A, 2) * size(B, 2) * size(C, 2))
        X = randn(size(A, 2) * size(B, 2) * size(C, 2), 4)
        y = randn(size(A, 1) * size(B, 1) * size(C, 1))
        Y = randn(size(A, 1) * size(B, 1) * size(C, 1), 4)

        K1 = kronecker(A, B, C)
        K2 = kronecker(B, A, C)
        k1 = kron(A, B, C)
        k2 = kron(B, A, C)

        for (K, k) in [(K1, k1), (K2, k2)]
            compare_against_kron(K, k, x, X, y, Y)
        end
    end


    @testset "10-factor square KroneckerProduct" begin
        matrices = [randn(2, 2) for i in 1:10]
        v = randn(2^10)
        V = randn(2^10, 5)

        KP = kronecker(matrices...)
        KS = kroneckersum(matrices...)
        kp = kron(matrices...)
        ks = collect(KS)

        for (K, k) in [(KP, kp), (KS, ks)]
            compare_against_kron(K, k, v, V, v, V)
        end
    end

    @testset "10-factor square KroneckerPower" begin
        # reduce condition number of the matrix to avoid accidentally triggering a
        #  test failure
        A = randn(2, 2) + 20I
        A /= opnorm(A)

        v = randn(2^10)
        V = randn(2^10, 5)

        K = kronecker(ntuple(_ -> A, 10)...)
        k = kron(ntuple(_ -> A, 10)...)

        compare_against_kron(K, k, v, V, v, V)
    end

    @testset "10-factor rectangular KroneckerProduct" begin
        matrices = [randn(3, 2) for i in 1:10]
        x = randn(2^10)
        X = randn(2^10, 5)
        y = randn(3^10)
        Y = randn(3^10, 5)

        K = kronecker(matrices...)
        k = kron(matrices...)

        compare_against_kron(K, k, x, X, y, Y)
    end

    @testset "10-factor mixed KroneckerProduct" begin
        matrices1 = [randn(2, 2) for i in 1:5]
        matrices2 = [randn(3, 2) for i in 1:5]
        x = randn(2^10)
        X = randn(2^10, 5)
        y = randn(2^5 * 3^5)
        Y = randn(2^5 * 3^5, 5)

        K = kronecker(matrices1..., matrices2...)
        k = kron(matrices1..., matrices2...)

        @test collect(K) ≈ k

        compare_against_kron(K, k, x, X, y, Y)
    end

    @testset "mixed products" begin
        # square matrices
        A = rand(5, 5)
        B = rand(Bool, 5, 5)
        C = rand(-10:10, 5, 5)
        v = randn(5^3)

        @test (A ⊗ B ⊗ C) * v ≈ collect(A ⊗ B ⊗ C) * v
        @test (A ⊗ B ⊗ A) * v ≈ collect(A ⊗ B ⊗ A) * v
        @test (B ⊗ B ⊗ C) * v ≈ collect(B ⊗ B ⊗ C) * v

        # rectangular

        A = rand(5, 5)
        B = rand(Bool, 4, 5)
        C = rand(-10:10, 5, 3)
        v = randn(5 * 5 * 3)
        @test (A ⊗ B ⊗ C) * v ≈ collect(A ⊗ B ⊗ C) * v
        @test (C ⊗ B ⊗ A) * v ≈ collect(C ⊗ B ⊗ A) * v
    end

    @testset "diagonal kronecker product" begin
        D1 = Diagonal(ones(Int, 3))
        K = kronecker(D1, D1)
        K3 = kronecker(D1, 3)
        Kdense = kron(D1, D1)
        K3dense = kron(D1, D1, D1)
        @testset "with kronecker" begin
            @test K * K == Kdense * Kdense
            @test K3 * K3 == K3dense * K3dense
        end
        @testset "with diagonal" begin
            D2 = Diagonal(ones(Int, 3) .* 2)
            D = kron(D2, D2)
            D3 = kron(D2, D2, D2)
            for (_K, _Kdense, _D) in Any[(K, Kdense, D), (K3, K3dense, D3)]
                _Kcollect = collect(_K)
                @test _K * _D == _Kdense * _D == _Kcollect * collect(_D)
                @test _D * _K == _Kdense * _D == collect(_D) * _Kcollect
            end
        end
        @testset "with triangular" begin
            for (_K, _Kdense) in Any[(K, Kdense), (K3, K3dense)]
                L = LowerTriangular(reshape(1:length(_K), size(_K)))
                U = UpperTriangular(reshape(1:length(_K), size(_K)))
                _Kcollect = collect(_K)
                for M in [L, U]
                    @test _K * M == _Kcollect * collect(M) == _Kdense * M
                    @test M * _K == collect(M) * _Kcollect == M * _Kdense
                end
            end
        end
        @testset "with vector" begin
            v = [i for i in axes(K, 2)]
            @test K * v == Kdense * v
        end
        @testset "with adjoint" begin
            vadj = [i for i in axes(K, 1)]'
            @test vadj * K == vadj * Kdense
            vt = transpose([i for i in axes(K, 1)])
            @test vt * K == vt * Kdense
        end
    end

    @testset "multiplication with structured matrices" begin
        for m in [2, 3]
            M = reshape([1:2m;], 2, m)
            K = kronecker(M, M)
            K3 = kronecker(M, 3)
            for _K in [K, K3]
                ML = reshape(1:size(_K, 1)^2, size(_K, 1), size(_K, 1))
                MR = reshape(1:size(_K, 2)^2, size(_K, 2), size(_K, 2))
                LL = LowerTriangular(ML)
                UL = UpperTriangular(ML)
                for _M in [LL, UL]
                    @test _M * _K == collect(_M) * collect(_K)
                end
                LR = LowerTriangular(MR)
                UR = UpperTriangular(MR)
                for _M in [LR, UR]
                    @test _K * _M == collect(_K) * collect(_M)
                end
            end
        end
    end
end

# Basic use

Compute a lazy Kronecker products between two matrices `A` and `B` by either

```julia
K = kronecker(A, B)
```

or, by using the binary operator:

```julia
K = A ⊗ B
```

Note, `⊗` can be formed by typing `\otimes<tab>`.

The Kronecker product `K` behaves like a matrix, for which `size(K)`, `eltype(K)` works as one would expect. Elements can be accessed via `K[i,j]`; every element is computed on the fly. The function `collect` can be used to turn `K` in a regular, dense matrix.

```@repl
using Kronecker
A = randn(4, 4)
B = rand(1:10, 5, 7)
K = A ⊗ B
K[4, 5]
eltype(K)  # promotion
collect(K)
```

## Constructing Kronecker products

```@docs
kronecker
⊗
collect(::AbstractKroneckerProduct)
```

## Basic properties of Kronecker products

```@docs
getindex
eltype
size(::AbstractKroneckerProduct)
collect
collect!
order
getmatrices
issquare
issymmetric
sum
```

## Linear algebra

Many functions of the `LinearAlgebra` module are overloaded to work with subtypes of `GeneralizedKroneckerProduct`.

```@docs
det(K::AbstractKroneckerProduct)
logdet(K::AbstractKroneckerProduct)
tr(K::AbstractKroneckerProduct)
inv(K::AbstractKroneckerProduct)
adjoint(K::AbstractKroneckerProduct)
transpose(K::AbstractKroneckerProduct)
conj(K::AbstractKroneckerProduct)
```

# Multiplication

`Kronecker.jl` allows for efficient multiplication of large Kronecker systems by overloading the multiplication function `*`. We distinguish three cases:

- **Kronecker-Kronecker multiplications** yield again a type of `AbstractKroneckerProduct`;
- **Kronecker-vector multiplications** use the 'vec trick' and yield a vector;
- **sampled Kronecker-vector multiplications** use the sampled-vec trick to yield a vector.

## Kronecker-kronecker multiplications

Multiplying two conformable Kronecker products of the same order yield a new Kronecker product, based on the mixed-product property:

```math
(A \otimes B)(C \otimes D) = (AC) \otimes (BD),
```

```@example
using Kronecker # hide
A, B, C, D = randn(5, 5), randn(4, 4), randn(5, 4), randn(4, 4);
(A ⊗ B) * (C ⊗ D)
```

## The Vec trick

Reshaping allows computing a product between a Kronecker product and vector as two matrix multiplications. This is the so-called vec trick which holds for any set of conformable matrices:

```math
(A \otimes B) \text{vec}(X) = \text{vec}(B^\intercal X A).
```

Here, $\text{vec}(\cdot)$ is the vectorization operator, which stacks all columns of a matrix into a vector.

```@example
using Kronecker # hide
A, B = rand(10, 10), rand(5, 6);
x = randn(60);
(A ⊗ B) * x
```

Note that this trick is extended to also work with matrices:

```@example
using Kronecker # hide
A, B = rand(10, 10), rand(5, 6);
x = randn(60, 2);
(A ⊗ B) * x
```

The vec trick works with higher-order Kronecker products. **However, at the moment this has a substantial overhead and likely be relatively slow.**

## Docstrings

```@docs
mul!
lmul!
rmul!
```

## Sampled Kronecker-vector multiplications

See [Indexed Kronecker products](@ref) for the specifics.

# Kronecker.jl

*A general-purpose toolbox for efficient Kronecker-based algebra.*

`Kronecker.jl` is a Julia package for working with large-scale Kronecker systems. The main feature of `Kronecker.jl` is providing a function `kronecker(A, B)` used to obtain an instance of the lazy `GeneralizedKroneckerProduct` type. In contrast to the native Julia function `kron(A, B)`, this does not compute the Kronecker product but instead stores the matrices in a specialized structure.

Commonly-used mathematical functions are overloaded to provide the most efficient methods to work with Kronecker products. We also provide an equivalent binary operator `⊗` which can be used directly as a Kronecker product in statements, i.e., `A ⊗ B`.

```@contents
Pages = [
    "man/basic.md",
    "man/types.md",
    "man/multiplication.md"
    "man/factorization.md",
    "man/indexed.md",
    "man/kroneckersums.md",
    "man/kroneckerpowers.md"
]
```

## Package features

- `tr`, `det`, `size`, `eltype`, `inv`, ... are efficient functions to work with Kronecker products. Either the result is a numeric value, or returns a new `KroneckerProduct` type.
- Kronecker product - vector multiplications are performed using the vec trick. Two Kronecker products of conformable size can be multiplied efficiently, yielding another Kronecker product.
- Working with incomplete systems using the [sampled vec trick](https://arxiv.org/pdf/1601.01507.pdf).
- Overloading of the function `eigen` to compute eigenvalue decompositions of Kronecker products. It can be used to efficiently solve systems of the form `(A ⊗ B +λI) \ v`.
- Higher-order Kronecker systems are supported: most functions work on `A ⊗ B ⊗ C` or systems of arbitrary order.
  - Efficient sampling of [Kronecker graphs](https://cs.stanford.edu/~jure/pubs/kronecker-jmlr10.pdf) is supported.
- Kronecker powers are supported: `kronecker(A, 3)` or `A ⊗ 3`.
- A `KroneckerSum` can be constructed with `A ⊕ B` (typed using `\oplus TAB`) or `kroneckersum(A,B)`.
  - Multiplication with vectors uses  a specialized version of the vec trick
  - Higher-order sums are supported, e.g. `A ⊕ B ⊕ C` or `kroneckersum(A,4)`.

## Example use

```@repl
using Kronecker, LinearAlgebra

A = [1.0 2.0;
     3.0 5.0];
B = Array{Float64, 2}([1 2 3;
            4 5 6;
            7 -2 9]);

K = A ⊗ B

collect(K)  # yield the dense matrix

tr(K)

det(K)

K'  # (conjugate transpose)

inv(K')

K * K  # (A * A) ⊗ (B * B)

v = collect(1:6)

K * v
```

# Types

The abstract type at the top of the hierarchy of `Kronecker.jl`'s type system is `GeneralizedKroneckerProduct` a subtype of `AbstractMatrix`. `GeneralizedKroneckerProduct` contains all subtypes which contain a Kronecker product.

Pure Kronecker products, i.e., all expressions that one can write as `A ⊗ B`, with `A` and `B` `AbstractMatix` types are part of the abstract type `AbstractKroneckerProduct <: GeneralizedKroneckerProduct`. Concrete instantiations are stored in the structure `KroneckerProduct <: AbstractKroneckerProduct`, a container for `A` and `B`. Instances of `KroneckerProduct` structs are annotated with the element type of the Kronecker product (promoted from the element types of `A` and `B`) and the types of `A` and `B`.

For Kronecker powers, iterative multiplications of the same matrix, i.e.,

```math
\bigotimes_{i=1}^K A = A\otimes A \otimes \ldots \otimes A\,,
```

are stored in the structure `KroneckerPower <: AbstractKroneckerProduct`. This is more efficient, as it only processes a single matrix, irregardless of the order of the product.

Special cases are `KroneckerSum <: AbstractKroneckerSum <: GeneralizedKroneckerProduct` for the Kronecker sum:

```math
A \oplus B = A \otimes I + I \otimes B\,.
```

These work similar to instances of `AbstractKroneckerProduct`.

Finally, we have `IndexedKroneckerProduct <: GeneralizedKroneckerProduct`, which stores submatrices of a Kronecker product. This contains both the Kronecker product as well as the indices.

It is important to note that since all instances of subtypes of `GeneralizedKroneckerProduct` are instances of an `AbstractMatrix`, it is possible to combine them at heart. This is because Kronecker products are between any types of matrices, which Kronecker products themselves are.

# Kronecker sums

A Kronecker sum between two square matrices of the same size is defined as

```math
A \oplus B = A ⊗ I + I \oplus B\,.
```

To construct objects of the `KroneckerSum` type, one can either use `kroneckersum` or the binary operator `⊕`. Lazy Kronecker sums work like lazy Kronecker products, though there are far fewer methods to process these constructs efficiently. The most important property for Kronecker sums relates to matrix exponentiation:
```math
\exp(A \oplus B) = \exp(A) \otimes \exp(B)\,.
```
The function `collect` can be used to transform a `KroneckerSum` struct into a sparse array. It is recommended to make it 'dense' this way before doing operations such as multiplication with a vector.

```@repl
using Kronecker # hide
A, B = rand(Bool, 5, 5), rand(4, 4);
K = A ⊕ B
exp(K)
collect(K)
```

```@docs
kroneckersum
⊕
collect(K::AbstractKroneckerSum)
exp
mul!(x::AbstractVector, K::AbstractKroneckerSum, v::AbstractVector)
```

# Factorization methods

Many forms of matrix factorization such as eigenvalue decomposition, LU factorization, Cholesky factorization etc., can be computed efficiently. The decomposition of the Kronecker product is the Kronecker product of the decompositions. We have overloaded some of the factorization functions from `LinearAlgebra` to compute the factorization of instances of `AbstractKroneckerProduct`.

## Eigenvalue decomposition

The function `eigen` of `LinearAlgebra` is overloaded to compute the decomposition of `AbstractKroneckerProduct`s. The result is a factorization of the `Eigen` type, containing a vector of the eigenvalues and a matrix with the eigenvectors. Just like long-time users would expect! The eigenvectors are structured as Kronecker products and can be processed accordingly.

The functions `det`, `logdet`, `inv` and `\` are overloaded the make use of this decomposition.

The eigenvalue decomposition of matrices can be used to solve large systems of the form:

```math
(A \otimes B + c\cdot I) \mathbf{x} = \mathbf{b}
```

The case where $A$ and $B$ are positive semi-definite frequently occurs in machine learning, for example in ridge regression.

```@repl
using Kronecker, LinearAlgebra # hide
A, B = rand(10, 10), randn(4, 4);
As, Bs = (A, B) .|> X -> X * X';  # make positive definite
K = As ⊗ Bs
E = eigen(K)
logdet(E)
b = randn(40);
(E + 0.1I) \ b  # solve a system
```

```@docs
eigen
+(E::Eigen, B::UniformScaling)
+(::Eigen, ::UniformScaling)

det(E::Eigen{<:Number, <:Number, <:AbstractKroneckerProduct})
logdet(E::Eigen{<:Number, <:Number, <:AbstractKroneckerProduct})
inv(E::Eigen{<:Number, <:Number, <:AbstractKroneckerProduct})
```

## Cholesky factorization

Similar to the eigenvalue decomposition, `cholesky` has been overloaded to allow for efficient Cholesky decomposition of Kronecker products of symmetric and positive definite matrices.

```@repl
using Kronecker, LinearAlgebra # hide
A, B = rand(10, 10), randn(4, 4);
As, Bs = (A, B) .|> X -> X * X';  # make positive definite
K = As ⊗ Bs
C = cholesky(K)
logdet(C)
inv(C)
```

```@docs
cholesky
```

# Kronecker powers and graphs

## Kronecker powers

Repeated Kronecker multiplications of the same matrix, i.e.

```math
A^{\otimes n}=\otimes_{i=1}^n A = \underbrace{A \otimes A \otimes \ldots \otimes A}_{n\text{ times}}\,.
```

Kronecker powers are supported using `kronecker(A, n)` or, equivalently, `⊗(A, n)`. These functions yield an instance of `KroneckerPower`, as struct which holds the matrix and the power. It works just like instances of `KroneckerProduct`, but more efficient since only a single matrix has to be stored and manipulated. These products work as expected.

```@repl
using Kronecker
A = rand(2, 2)
K2 = A ⊗ 2
inv(K2)
K12 = K2 ⊗ 6  # works recursively
K12^2  # example
```

```@docs
kronecker(A::AbstractMatrix, pow::Int)
⊗(A::AbstractMatrix, pow::Int)
```

## Kronecker graphs

An exciting application of Kronecker powers (or Krocker products in general) is generating large, realistic graphs from an initial 'seed' via a stochastic process. This is called a Kronecker graph and is described in detail in [Leskovec et al. (2008)](https://cs.stanford.edu/~jure/pubs/kronecker-jmlr10.pdf).

If we use an initial matrix $P$ with values in $[0,1]$ as a seed, then $P_n=P^{\otimes n}$ can be seen as a probability distribution for an adjacency matrix of a graph. The elements $(P_n)_{i,j}$ give the probabilities that there is an edge from node $i$ to node $j$. Leskovec and co-authors give two algorithms for sampling adjacency matrices from this distribution, both provided by `Kronecker.jl`:

- `naivesample` gives exact samples, but has a computational time proportional to the number of elements and hence prohibitive for large graphs;
- `fastsample` a recursive heuristic, has a computational time proportional to the expected number of edges in the graph.

The latter can easily scale to generate graphs of millions of nodes. Both return the adjacency matrix as a sparse array.

```@repl
using Kronecker
P = rand(2, 2)
P10 = P ⊗ 10
sum(P10)  # expected number of edges
A = fastsample(P10)
```

```@docs
isprob
naivesample
fastsample
```
